/* XNode.c generated by valac 0.56.17, the Vala compiler
 * generated from XNode.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; c-basic-offset: 0; tab-width: 2 -*- */
/* ObjectModel.vala
 *
 * Copyright (C) 2015  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gxml/gxml.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <libxml/tree.h>
#include <libxml/xmlerror.h>
#include <glib/gi18n-lib.h>
#include <libxml/parser.h>
#include "gxml.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GXML_XNODE_0_PROPERTY,
	GXML_XNODE_ATTRS_PROPERTY,
	GXML_XNODE_CHILDREN_NODES_PROPERTY,
	GXML_XNODE_DOCUMENT_PROPERTY,
	GXML_XNODE_PARENT_PROPERTY,
	GXML_XNODE_TYPE_NODE_PROPERTY,
	GXML_XNODE_NAME_PROPERTY,
	GXML_XNODE_VALUE_PROPERTY,
	GXML_XNODE_NODE_TYPE_PROPERTY,
	GXML_XNODE_NODE_NAME_PROPERTY,
	GXML_XNODE_BASE_URI_PROPERTY,
	GXML_XNODE_OWNER_DOCUMENT_PROPERTY,
	GXML_XNODE_PARENT_NODE_PROPERTY,
	GXML_XNODE_PARENT_ELEMENT_PROPERTY,
	GXML_XNODE_CHILD_NODES_PROPERTY,
	GXML_XNODE_FIRST_CHILD_PROPERTY,
	GXML_XNODE_LAST_CHILD_PROPERTY,
	GXML_XNODE_PREVIOUS_SIBLING_PROPERTY,
	GXML_XNODE_NEXT_SIBLING_PROPERTY,
	GXML_XNODE_NODE_VALUE_PROPERTY,
	GXML_XNODE_TEXT_CONTENT_PROPERTY,
	GXML_XNODE_NUM_PROPERTIES
};
static GParamSpec* gxml_xnode_properties[GXML_XNODE_NUM_PROPERTIES];
#define _xmlFreeNode0(var) ((var == NULL) ? NULL : (var = (xmlFreeNode (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

/**
 * Auxiliary error codes for parsing/writing libxml2 powered classes
 */

static gpointer gxml_xnode_parent_class = NULL;
static GXmlDomEventTargetIface * gxml_xnode_gxml_dom_event_target_parent_iface = NULL;
static GXmlDomNodeIface * gxml_xnode_gxml_dom_node_parent_iface = NULL;

VALA_EXTERN gchar* gxml_xnode_libxml2_error_to_string (xmlError* e);
static const char* _xml_error_level_to_string (xmlErrorLevel value);
static gboolean gxml_xnode_real_set_namespace (GXmlXNode* self,
                                        const gchar* uri,
                                        const gchar* prefix);
static gchar* gxml_xnode_real_to_string (GXmlXNode* self);
VALA_EXTERN void gxml_xnode_take_node (GXmlXNode* self);
VALA_EXTERN void gxml_xnode_release_node (GXmlXNode* self);
static gboolean gxml_xnode_real_has_child_nodes (GXmlDomNode* base);
static void gxml_xnode_real_normalize (GXmlDomNode* base);
static gboolean gxml_xnode_real_is_equal_node (GXmlDomNode* base,
                                        GXmlDomNode* node);
static GXmlDomNodeDocumentPosition gxml_xnode_real_compare_document_position (GXmlDomNode* base,
                                                                       GXmlDomNode* other);
static gboolean gxml_xnode_real_contains (GXmlDomNode* base,
                                   GXmlDomNode* other);
static gchar* gxml_xnode_real_lookup_prefix (GXmlDomNode* base,
                                      const gchar* nspace);
static gchar* gxml_xnode_real_lookup_namespace_uri (GXmlDomNode* base,
                                             const gchar* prefix);
static gboolean gxml_xnode_real_is_default_namespace (GXmlDomNode* base,
                                               const gchar* nspace);
static GXmlDomNode* gxml_xnode_real_insert_before (GXmlDomNode* base,
                                            GXmlDomNode* node,
                                            GXmlDomNode* child,
                                            GError** error);
static GXmlDomNode* gxml_xnode_real_append_child (GXmlDomNode* base,
                                           GXmlDomNode* node,
                                           GError** error);
static GXmlDomNode* gxml_xnode_real_replace_child (GXmlDomNode* base,
                                            GXmlDomNode* node,
                                            GXmlDomNode* child,
                                            GError** error);
static GXmlDomNode* gxml_xnode_real_remove_child (GXmlDomNode* base,
                                           GXmlDomNode* child,
                                           GError** error);
static void gxml_xnode_real_add_event_listener (GXmlDomEventTarget* base,
                                         const gchar* type,
                                         GXmlDomEventListener* callback,
                                         gboolean capture);
static void gxml_xnode_real_remove_event_listener (GXmlDomEventTarget* base,
                                            const gchar* type,
                                            GXmlDomEventListener* callback,
                                            gboolean capture);
static gboolean gxml_xnode_real_dispatch_event (GXmlDomEventTarget* base,
                                         GXmlDomEvent* event,
                                         GError** error);
static GObject * gxml_xnode_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
VALA_EXTERN void gxml_init_init (void);
static void gxml_xnode_finalize (GObject * obj);
static GType gxml_xnode_get_type_once (void);
static void _vala_gxml_xnode_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_gxml_xnode_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
gxml_error_quark (void)
{
#line 245 "../gxml/Parser.vala"
	return g_quark_from_static_string ("gxml-error-quark");
#line 156 "XNode.c"
}

static GType
gxml_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GXML_ERROR_NOT_SUPPORTED, "GXML_ERROR_NOT_SUPPORTED", "not-supported"}, {GXML_ERROR_PARSER, "GXML_ERROR_PARSER", "parser"}, {GXML_ERROR_WRITER, "GXML_ERROR_WRITER", "writer"}, {0, NULL, NULL}};
	GType gxml_error_type_id;
	gxml_error_type_id = g_enum_register_static ("GXmlError", values);
	return gxml_error_type_id;
}

GType
gxml_error_get_type (void)
{
	static volatile gsize gxml_error_type_id__once = 0;
	if (g_once_init_enter (&gxml_error_type_id__once)) {
		GType gxml_error_type_id;
		gxml_error_type_id = gxml_error_get_type_once ();
		g_once_init_leave (&gxml_error_type_id__once, gxml_error_type_id);
	}
	return gxml_error_type_id__once;
}

static const char*
_xml_error_level_to_string (xmlErrorLevel value)
{
#line 44 "../gxml/XNode.vala"
	switch (value) {
#line 44 "../gxml/XNode.vala"
		case XML_ERR_NONE:
#line 44 "../gxml/XNode.vala"
		return "XML_ERR_NONE";
#line 44 "../gxml/XNode.vala"
		case XML_ERR_WARNING:
#line 44 "../gxml/XNode.vala"
		return "XML_ERR_WARNING";
#line 44 "../gxml/XNode.vala"
		case XML_ERR_ERROR:
#line 44 "../gxml/XNode.vala"
		return "XML_ERR_ERROR";
#line 44 "../gxml/XNode.vala"
		case XML_ERR_FATAL:
#line 44 "../gxml/XNode.vala"
		return "XML_ERR_FATAL";
#line 201 "XNode.c"
	}
#line 44 "../gxml/XNode.vala"
	return NULL;
#line 205 "XNode.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 227 "XNode.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 231 "XNode.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 237 "XNode.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 241 "XNode.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 245 "XNode.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 253 "XNode.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 281 "XNode.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 290 "XNode.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 304 "XNode.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 313 "XNode.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 327 "XNode.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 336 "XNode.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 345 "XNode.c"
}

gchar*
gxml_xnode_libxml2_error_to_string (xmlError* e)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 47 "../gxml/XNode.vala"
	_tmp1_ = (*e).file;
#line 47 "../gxml/XNode.vala"
	if (_tmp1_ == NULL) {
#line 47 "../gxml/XNode.vala"
		_tmp0_ = "<io>";
#line 370 "XNode.c"
	} else {
		const gchar* _tmp2_;
#line 47 "../gxml/XNode.vala"
		_tmp2_ = (*e).file;
#line 47 "../gxml/XNode.vala"
		_tmp0_ = _tmp2_;
#line 377 "XNode.c"
	}
#line 44 "../gxml/XNode.vala"
	_tmp3_ = _xml_error_level_to_string ((*e).level);
#line 44 "../gxml/XNode.vala"
	_tmp4_ = string_replace (_tmp3_, "XML_ERR_", "");
#line 44 "../gxml/XNode.vala"
	_tmp5_ = _tmp4_;
#line 44 "../gxml/XNode.vala"
	_tmp6_ = g_strdup_printf ("%i", (*e).domain);
#line 44 "../gxml/XNode.vala"
	_tmp7_ = _tmp6_;
#line 44 "../gxml/XNode.vala"
	_tmp8_ = string_replace (_tmp7_, "XML_FROM_", "");
#line 44 "../gxml/XNode.vala"
	_tmp9_ = _tmp8_;
#line 44 "../gxml/XNode.vala"
	_tmp10_ = (*e).message;
#line 44 "../gxml/XNode.vala"
	_tmp11_ = g_strdup_printf (_ ("%s:%s:%d: %s:%d: %s"), _tmp5_, _tmp9_, (*e).code, _tmp0_, (*e).line, _tmp10_);
#line 44 "../gxml/XNode.vala"
	_tmp12_ = _tmp11_;
#line 44 "../gxml/XNode.vala"
	_g_free0 (_tmp9_);
#line 44 "../gxml/XNode.vala"
	_g_free0 (_tmp7_);
#line 44 "../gxml/XNode.vala"
	_g_free0 (_tmp5_);
#line 44 "../gxml/XNode.vala"
	result = _tmp12_;
#line 44 "../gxml/XNode.vala"
	return result;
#line 409 "XNode.c"
}

static gboolean
gxml_xnode_real_set_namespace (GXmlXNode* self,
                               const gchar* uri,
                               const gchar* prefix)
{
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	xmlNs* _tmp2_;
	gboolean result;
#line 62 "../gxml/XNode.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 64 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 64 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 64 "../gxml/XNode.vala"
		result = FALSE;
#line 64 "../gxml/XNode.vala"
		return result;
#line 431 "XNode.c"
	}
#line 65 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 65 "../gxml/XNode.vala"
	_tmp2_ = xmlNewNs (_tmp1_, (xmlChar*) uri, (xmlChar*) prefix);
#line 65 "../gxml/XNode.vala"
	result = _tmp2_ != NULL;
#line 65 "../gxml/XNode.vala"
	return result;
#line 441 "XNode.c"
}

gboolean
gxml_xnode_set_namespace (GXmlXNode* self,
                          const gchar* uri,
                          const gchar* prefix)
{
	GXmlXNodeClass* _klass_;
#line 62 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 62 "../gxml/XNode.vala"
	if (_klass_->set_namespace) {
#line 62 "../gxml/XNode.vala"
		return _klass_->set_namespace (self, uri, prefix);
#line 458 "XNode.c"
	}
#line 62 "../gxml/XNode.vala"
	return FALSE;
#line 462 "XNode.c"
}

GeeMap*
gxml_xnode_get_attrs (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 67 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 67 "../gxml/XNode.vala"
	if (_klass_->get_attrs) {
#line 67 "../gxml/XNode.vala"
		return _klass_->get_attrs (self);
#line 477 "XNode.c"
	}
#line 67 "../gxml/XNode.vala"
	return NULL;
#line 481 "XNode.c"
}

static GeeMap*
gxml_xnode_real_get_attrs (GXmlXNode* base)
{
	GeeMap* result;
	GXmlXNode* self;
	GXmlXDocument* _tmp0_;
	xmlNode* _tmp1_;
	GXmlXHashMapAttr* _tmp2_;
	GeeMap* _tmp3_;
#line 67 "../gxml/XNode.vala"
	self = base;
#line 67 "../gxml/XNode.vala"
	_tmp0_ = self->_doc;
#line 67 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 67 "../gxml/XNode.vala"
	_tmp2_ = gxml_xhash_map_attr_new (_tmp0_, _tmp1_);
#line 67 "../gxml/XNode.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GEE_TYPE_MAP) ? ((GeeMap*) _tmp2_) : NULL;
#line 67 "../gxml/XNode.vala"
	if (_tmp3_ == NULL) {
#line 67 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp2_);
#line 507 "XNode.c"
	}
#line 67 "../gxml/XNode.vala"
	result = _tmp3_;
#line 67 "../gxml/XNode.vala"
	return result;
#line 513 "XNode.c"
}

GeeBidirList*
gxml_xnode_get_children_nodes (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 68 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 68 "../gxml/XNode.vala"
	if (_klass_->get_children_nodes) {
#line 68 "../gxml/XNode.vala"
		return _klass_->get_children_nodes (self);
#line 528 "XNode.c"
	}
#line 68 "../gxml/XNode.vala"
	return NULL;
#line 532 "XNode.c"
}

static GeeBidirList*
gxml_xnode_real_get_children_nodes (GXmlXNode* base)
{
	GeeBidirList* result;
	GXmlXNode* self;
	GXmlXDocument* _tmp0_;
	xmlNode* _tmp1_;
	GXmlXListChildren* _tmp2_;
	GeeBidirList* _tmp3_;
#line 68 "../gxml/XNode.vala"
	self = base;
#line 68 "../gxml/XNode.vala"
	_tmp0_ = self->_doc;
#line 68 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 68 "../gxml/XNode.vala"
	_tmp2_ = gxml_xlist_children_new (_tmp0_, _tmp1_);
#line 68 "../gxml/XNode.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GEE_TYPE_BIDIR_LIST) ? ((GeeBidirList*) _tmp2_) : NULL;
#line 68 "../gxml/XNode.vala"
	if (_tmp3_ == NULL) {
#line 68 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp2_);
#line 558 "XNode.c"
	}
#line 68 "../gxml/XNode.vala"
	result = _tmp3_;
#line 68 "../gxml/XNode.vala"
	return result;
#line 564 "XNode.c"
}

GXmlDomDocument*
gxml_xnode_get_document (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 69 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 69 "../gxml/XNode.vala"
	if (_klass_->get_document) {
#line 69 "../gxml/XNode.vala"
		return _klass_->get_document (self);
#line 579 "XNode.c"
	}
#line 69 "../gxml/XNode.vala"
	return NULL;
#line 583 "XNode.c"
}

static GXmlDomDocument*
gxml_xnode_real_get_document (GXmlXNode* base)
{
	GXmlDomDocument* result;
	GXmlXNode* self;
	GXmlXDocument* _tmp0_;
#line 69 "../gxml/XNode.vala"
	self = base;
#line 69 "../gxml/XNode.vala"
	_tmp0_ = self->_doc;
#line 69 "../gxml/XNode.vala"
	result = (GXmlDomDocument*) _tmp0_;
#line 69 "../gxml/XNode.vala"
	return result;
#line 600 "XNode.c"
}

GXmlDomNode*
gxml_xnode_get_parent (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 71 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 71 "../gxml/XNode.vala"
	if (_klass_->get_parent) {
#line 71 "../gxml/XNode.vala"
		return _klass_->get_parent (self);
#line 615 "XNode.c"
	}
#line 71 "../gxml/XNode.vala"
	return NULL;
#line 619 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_get_parent (GXmlXNode* base)
{
	GXmlDomNode* result;
	GXmlXNode* self;
	GXmlDomNode* nullnode = NULL;
	xmlNode* _tmp0_;
	GXmlDomDocument* _tmp1_;
	GXmlDomDocument* _tmp2_;
	xmlNode* _tmp3_;
	xmlNode* _tmp4_;
	GXmlDomNode* _tmp5_;
#line 71 "../gxml/XNode.vala"
	self = base;
#line 72 "../gxml/XNode.vala"
	nullnode = NULL;
#line 73 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 73 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 73 "../gxml/XNode.vala"
		result = nullnode;
#line 73 "../gxml/XNode.vala"
		return result;
#line 646 "XNode.c"
	}
#line 74 "../gxml/XNode.vala"
	_tmp1_ = gxml_xnode_get_document (self);
#line 74 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 74 "../gxml/XNode.vala"
	_tmp3_ = self->_node;
#line 74 "../gxml/XNode.vala"
	_tmp4_ = _tmp3_->parent;
#line 74 "../gxml/XNode.vala"
	_tmp5_ = gxml_xnode_to_gnode (GXML_IS_XDOCUMENT (_tmp2_) ? ((GXmlXDocument*) _tmp2_) : NULL, _tmp4_, FALSE);
#line 74 "../gxml/XNode.vala"
	result = _tmp5_;
#line 74 "../gxml/XNode.vala"
	_g_object_unref0 (nullnode);
#line 74 "../gxml/XNode.vala"
	return result;
#line 664 "XNode.c"
}

GXmlNodeType
gxml_xnode_get_type_node (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 78 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 78 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 78 "../gxml/XNode.vala"
	if (_klass_->get_type_node) {
#line 78 "../gxml/XNode.vala"
		return _klass_->get_type_node (self);
#line 679 "XNode.c"
	}
#line 78 "../gxml/XNode.vala"
	return 0;
#line 683 "XNode.c"
}

static GXmlNodeType
gxml_xnode_real_get_type_node (GXmlXNode* base)
{
	GXmlNodeType result;
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
#line 78 "../gxml/XNode.vala"
	self = base;
#line 79 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 79 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 79 "../gxml/XNode.vala"
		result = GXML_NODE_TYPE_INVALID;
#line 79 "../gxml/XNode.vala"
		return result;
#line 703 "XNode.c"
	}
#line 80 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 80 "../gxml/XNode.vala"
	result = (GXmlNodeType) _tmp1_->type;
#line 80 "../gxml/XNode.vala"
	return result;
#line 711 "XNode.c"
}

gchar*
gxml_xnode_get_name (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 84 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 84 "../gxml/XNode.vala"
	if (_klass_->get_name) {
#line 84 "../gxml/XNode.vala"
		return _klass_->get_name (self);
#line 726 "XNode.c"
	}
#line 84 "../gxml/XNode.vala"
	return NULL;
#line 730 "XNode.c"
}

static gchar*
gxml_xnode_real_get_name (GXmlXNode* base)
{
	gchar* result;
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 84 "../gxml/XNode.vala"
	self = base;
#line 85 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 85 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 748 "XNode.c"
		gchar* _tmp1_;
#line 85 "../gxml/XNode.vala"
		_tmp1_ = g_strdup ("#noname");
#line 85 "../gxml/XNode.vala"
		result = _tmp1_;
#line 85 "../gxml/XNode.vala"
		return result;
#line 756 "XNode.c"
	}
#line 86 "../gxml/XNode.vala"
	_tmp2_ = self->_node;
#line 86 "../gxml/XNode.vala"
	_tmp3_ = _tmp2_->name;
#line 86 "../gxml/XNode.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 86 "../gxml/XNode.vala"
	result = _tmp4_;
#line 86 "../gxml/XNode.vala"
	return result;
#line 768 "XNode.c"
}

gchar*
gxml_xnode_get_value (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 91 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 91 "../gxml/XNode.vala"
	if (_klass_->get_value) {
#line 91 "../gxml/XNode.vala"
		return _klass_->get_value (self);
#line 783 "XNode.c"
	}
#line 91 "../gxml/XNode.vala"
	return NULL;
#line 787 "XNode.c"
}

static gchar*
gxml_xnode_real_get_value (GXmlXNode* base)
{
	gchar* result;
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp2_;
	gchar* _tmp3_;
#line 91 "../gxml/XNode.vala"
	self = base;
#line 92 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 92 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 804 "XNode.c"
		gchar* _tmp1_;
#line 92 "../gxml/XNode.vala"
		_tmp1_ = g_strdup ("");
#line 92 "../gxml/XNode.vala"
		result = _tmp1_;
#line 92 "../gxml/XNode.vala"
		return result;
#line 812 "XNode.c"
	}
#line 93 "../gxml/XNode.vala"
	_tmp2_ = self->_node;
#line 93 "../gxml/XNode.vala"
	_tmp3_ = (gchar*) xmlNodeGetContent (_tmp2_);
#line 93 "../gxml/XNode.vala"
	result = _tmp3_;
#line 93 "../gxml/XNode.vala"
	return result;
#line 822 "XNode.c"
}

void
gxml_xnode_set_value (GXmlXNode* self,
                      const gchar* value)
{
	GXmlXNodeClass* _klass_;
#line 95 "../gxml/XNode.vala"
	g_return_if_fail (self != NULL);
#line 95 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 95 "../gxml/XNode.vala"
	if (_klass_->set_value) {
#line 95 "../gxml/XNode.vala"
		_klass_->set_value (self, value);
#line 838 "XNode.c"
	}
}

static void
gxml_xnode_real_set_value (GXmlXNode* base,
                           const gchar* value)
{
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
#line 95 "../gxml/XNode.vala"
	self = base;
#line 96 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 96 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 96 "../gxml/XNode.vala"
		return;
#line 857 "XNode.c"
	}
#line 97 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 97 "../gxml/XNode.vala"
	xmlNodeSetContent (_tmp1_, (xmlChar*) value);
#line 95 "../gxml/XNode.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_xnode_properties[GXML_XNODE_VALUE_PROPERTY]);
#line 865 "XNode.c"
}

static gchar*
gxml_xnode_real_to_string (GXmlXNode* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 100 "../gxml/XNode.vala"
	_tmp0_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 100 "../gxml/XNode.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 100 "../gxml/XNode.vala"
	result = _tmp1_;
#line 100 "../gxml/XNode.vala"
	return result;
#line 882 "XNode.c"
}

gchar*
gxml_xnode_to_string (GXmlXNode* self)
{
	GXmlXNodeClass* _klass_;
#line 100 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../gxml/XNode.vala"
	_klass_ = GXML_XNODE_GET_CLASS (self);
#line 100 "../gxml/XNode.vala"
	if (_klass_->to_string) {
#line 100 "../gxml/XNode.vala"
		return _klass_->to_string (self);
#line 897 "XNode.c"
	}
#line 100 "../gxml/XNode.vala"
	return NULL;
#line 901 "XNode.c"
}

/**
   * Access to {@link Xml.Node} referenced
   */
xmlNode*
gxml_xnode_get_internal_node (GXmlXNode* self)
{
	xmlNode* _tmp0_;
	xmlNode* result;
#line 105 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 105 "../gxml/XNode.vala"
	result = _tmp0_;
#line 105 "../gxml/XNode.vala"
	return result;
#line 920 "XNode.c"
}

void
gxml_xnode_take_node (GXmlXNode* self)
{
#line 107 "../gxml/XNode.vala"
	g_return_if_fail (self != NULL);
#line 108 "../gxml/XNode.vala"
	self->owned_node = TRUE;
#line 930 "XNode.c"
}

void
gxml_xnode_release_node (GXmlXNode* self)
{
#line 111 "../gxml/XNode.vala"
	g_return_if_fail (self != NULL);
#line 112 "../gxml/XNode.vala"
	self->owned_node = FALSE;
#line 940 "XNode.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 141 "../gxml/XNode.vala"
	return self ? g_object_ref (self) : NULL;
#line 948 "XNode.c"
}

GXmlDomNode*
gxml_xnode_to_gnode (GXmlXDocument* doc,
                     xmlNode* node,
                     gboolean take_node)
{
	GXmlXNode* n = NULL;
	GXmlNodeType t = 0;
	gboolean _tmp6_ = FALSE;
	GXmlDomNode* result;
#line 115 "../gxml/XNode.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 116 "../gxml/XNode.vala"
	n = NULL;
#line 117 "../gxml/XNode.vala"
	t = (GXmlNodeType) node->type;
#line 118 "../gxml/XNode.vala"
	switch (t) {
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_ELEMENT:
#line 970 "XNode.c"
		{
			GXmlXElement* _tmp0_;
#line 120 "../gxml/XNode.vala"
			_tmp0_ = gxml_xelement_new (doc, node);
#line 120 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 120 "../gxml/XNode.vala"
			n = (GXmlXNode*) _tmp0_;
#line 121 "../gxml/XNode.vala"
			break;
#line 981 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_ATTRIBUTE:
#line 985 "XNode.c"
		{
			GXmlXAttribute* _tmp1_;
#line 123 "../gxml/XNode.vala"
			_tmp1_ = gxml_xattribute_new (doc, (xmlAttr*) node);
#line 123 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 123 "../gxml/XNode.vala"
			n = (GXmlXNode*) _tmp1_;
#line 124 "../gxml/XNode.vala"
			break;
#line 996 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_TEXT:
#line 1000 "XNode.c"
		{
			GXmlXText* _tmp2_;
#line 126 "../gxml/XNode.vala"
			_tmp2_ = gxml_xtext_new (doc, node);
#line 126 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 126 "../gxml/XNode.vala"
			n = (GXmlXNode*) _tmp2_;
#line 127 "../gxml/XNode.vala"
			break;
#line 1011 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_ENTITY_REFERENCE:
#line 1015 "XNode.c"
		{
#line 129 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 129 "../gxml/XNode.vala"
			n = NULL;
#line 130 "../gxml/XNode.vala"
			break;
#line 1023 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_ENTITY:
#line 1027 "XNode.c"
		{
#line 132 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 132 "../gxml/XNode.vala"
			n = NULL;
#line 133 "../gxml/XNode.vala"
			break;
#line 1035 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_PROCESSING_INSTRUCTION:
#line 1039 "XNode.c"
		{
			GXmlXProcessingInstruction* _tmp3_;
#line 135 "../gxml/XNode.vala"
			_tmp3_ = gxml_xprocessing_instruction_new (doc, node);
#line 135 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 135 "../gxml/XNode.vala"
			n = (GXmlXNode*) _tmp3_;
#line 136 "../gxml/XNode.vala"
			break;
#line 1050 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_COMMENT:
#line 1054 "XNode.c"
		{
			GXmlXComment* _tmp4_;
#line 138 "../gxml/XNode.vala"
			_tmp4_ = gxml_xcomment_new (doc, node);
#line 138 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 138 "../gxml/XNode.vala"
			n = (GXmlXNode*) _tmp4_;
#line 139 "../gxml/XNode.vala"
			break;
#line 1065 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_DOCUMENT:
#line 1069 "XNode.c"
		{
			GXmlXNode* _tmp5_;
#line 141 "../gxml/XNode.vala"
			_tmp5_ = _g_object_ref0 ((GXmlXNode*) doc);
#line 141 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 141 "../gxml/XNode.vala"
			n = _tmp5_;
#line 142 "../gxml/XNode.vala"
			break;
#line 1080 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_DOCUMENT_TYPE:
#line 1084 "XNode.c"
		{
#line 144 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 144 "../gxml/XNode.vala"
			n = NULL;
#line 145 "../gxml/XNode.vala"
			break;
#line 1092 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_DOCUMENT_FRAGMENT:
#line 1096 "XNode.c"
		{
#line 147 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 147 "../gxml/XNode.vala"
			n = NULL;
#line 148 "../gxml/XNode.vala"
			break;
#line 1104 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_NOTATION:
#line 1108 "XNode.c"
		{
#line 150 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 150 "../gxml/XNode.vala"
			n = NULL;
#line 151 "../gxml/XNode.vala"
			break;
#line 1116 "XNode.c"
		}
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_CDATA_SECTION:
#line 118 "../gxml/XNode.vala"
		case GXML_NODE_TYPE_INVALID:
#line 1122 "XNode.c"
		{
#line 154 "../gxml/XNode.vala"
			_g_object_unref0 (n);
#line 154 "../gxml/XNode.vala"
			n = NULL;
#line 155 "../gxml/XNode.vala"
			break;
#line 1130 "XNode.c"
		}
		default:
#line 118 "../gxml/XNode.vala"
		break;
#line 1135 "XNode.c"
	}
#line 158 "../gxml/XNode.vala"
	if (take_node) {
#line 1139 "XNode.c"
		GXmlXNode* _tmp7_;
#line 158 "../gxml/XNode.vala"
		_tmp7_ = n;
#line 158 "../gxml/XNode.vala"
		_tmp6_ = _tmp7_ != NULL;
#line 1145 "XNode.c"
	} else {
#line 158 "../gxml/XNode.vala"
		_tmp6_ = FALSE;
#line 1149 "XNode.c"
	}
#line 158 "../gxml/XNode.vala"
	if (_tmp6_) {
#line 1153 "XNode.c"
		GXmlXNode* _tmp8_;
#line 159 "../gxml/XNode.vala"
		_tmp8_ = n;
#line 159 "../gxml/XNode.vala"
		gxml_xnode_take_node (_tmp8_);
#line 1159 "XNode.c"
	}
#line 162 "../gxml/XNode.vala"
	result = (GXmlDomNode*) n;
#line 162 "../gxml/XNode.vala"
	return result;
#line 1165 "XNode.c"
}

static GXmlDomNodeNodeType
gxml_xnode_real_get_node_type (GXmlDomNode* base)
{
	GXmlDomNodeNodeType result;
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
#line 166 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 167 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 167 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 167 "../gxml/XNode.vala"
		result = GXML_DOM_NODE_NODE_TYPE_INVALID;
#line 167 "../gxml/XNode.vala"
		return result;
#line 1185 "XNode.c"
	}
#line 168 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 168 "../gxml/XNode.vala"
	switch (_tmp1_->type) {
#line 168 "../gxml/XNode.vala"
		case XML_ELEMENT_NODE:
#line 1193 "XNode.c"
		{
#line 170 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_ELEMENT_NODE;
#line 170 "../gxml/XNode.vala"
			return result;
#line 1199 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_ATTRIBUTE_NODE:
#line 1203 "XNode.c"
		{
#line 172 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_ATTRIBUTE_NODE;
#line 172 "../gxml/XNode.vala"
			return result;
#line 1209 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_TEXT_NODE:
#line 1213 "XNode.c"
		{
#line 174 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_TEXT_NODE;
#line 174 "../gxml/XNode.vala"
			return result;
#line 1219 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_CDATA_SECTION_NODE:
#line 1223 "XNode.c"
		{
#line 176 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_CDATA_SECTION_NODE;
#line 176 "../gxml/XNode.vala"
			return result;
#line 1229 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_ENTITY_REF_NODE:
#line 1233 "XNode.c"
		{
#line 178 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_ENTITY_REFERENCE_NODE;
#line 178 "../gxml/XNode.vala"
			return result;
#line 1239 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_ENTITY_NODE:
#line 1243 "XNode.c"
		{
#line 180 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_ENTITY_NODE;
#line 180 "../gxml/XNode.vala"
			return result;
#line 1249 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_PI_NODE:
#line 1253 "XNode.c"
		{
#line 182 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_PROCESSING_INSTRUCTION_NODE;
#line 182 "../gxml/XNode.vala"
			return result;
#line 1259 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_COMMENT_NODE:
#line 1263 "XNode.c"
		{
#line 184 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_COMMENT_NODE;
#line 184 "../gxml/XNode.vala"
			return result;
#line 1269 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_DOCUMENT_NODE:
#line 1273 "XNode.c"
		{
#line 186 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_DOCUMENT_NODE;
#line 186 "../gxml/XNode.vala"
			return result;
#line 1279 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_DOCUMENT_TYPE_NODE:
#line 1283 "XNode.c"
		{
#line 188 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_DOCUMENT_TYPE_NODE;
#line 188 "../gxml/XNode.vala"
			return result;
#line 1289 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_DOCUMENT_FRAG_NODE:
#line 1293 "XNode.c"
		{
#line 190 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_DOCUMENT_FRAGMENT_NODE;
#line 190 "../gxml/XNode.vala"
			return result;
#line 1299 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_NOTATION_NODE:
#line 1303 "XNode.c"
		{
#line 192 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_NOTATION_NODE;
#line 192 "../gxml/XNode.vala"
			return result;
#line 1309 "XNode.c"
		}
#line 168 "../gxml/XNode.vala"
		case XML_ATTRIBUTE_DECL:
#line 168 "../gxml/XNode.vala"
		case XML_XINCLUDE_START:
#line 168 "../gxml/XNode.vala"
		case XML_DTD_NODE:
#line 168 "../gxml/XNode.vala"
		case XML_ENTITY_DECL:
#line 168 "../gxml/XNode.vala"
		case XML_XINCLUDE_END:
#line 168 "../gxml/XNode.vala"
		case XML_ELEMENT_DECL:
#line 168 "../gxml/XNode.vala"
		case XML_NAMESPACE_DECL:
#line 168 "../gxml/XNode.vala"
		case XML_DOCB_DOCUMENT_NODE:
#line 168 "../gxml/XNode.vala"
		case XML_HTML_DOCUMENT_NODE:
#line 1329 "XNode.c"
		{
#line 202 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_NODE_TYPE_INVALID;
#line 202 "../gxml/XNode.vala"
			return result;
#line 1335 "XNode.c"
		}
		default:
#line 168 "../gxml/XNode.vala"
		break;
#line 1340 "XNode.c"
	}
#line 204 "../gxml/XNode.vala"
	result = GXML_DOM_NODE_NODE_TYPE_INVALID;
#line 204 "../gxml/XNode.vala"
	return result;
#line 1346 "XNode.c"
}

static gchar*
gxml_xnode_real_get_node_name (GXmlDomNode* base)
{
	gchar* result;
	GXmlXNode* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 207 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 207 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_name (self);
#line 207 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 207 "../gxml/XNode.vala"
	result = _tmp1_;
#line 207 "../gxml/XNode.vala"
	return result;
#line 1366 "XNode.c"
}

static const gchar*
gxml_xnode_real_get_base_uri (GXmlDomNode* base)
{
	const gchar* result;
	GXmlXNode* self;
	const gchar* _tmp0_;
#line 210 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 210 "../gxml/XNode.vala"
	_tmp0_ = self->_base_uri;
#line 210 "../gxml/XNode.vala"
	result = _tmp0_;
#line 210 "../gxml/XNode.vala"
	return result;
#line 1383 "XNode.c"
}

static GXmlDomDocument*
gxml_xnode_real_get_owner_document (GXmlDomNode* base)
{
	GXmlDomDocument* result;
	GXmlXNode* self;
	GXmlXDocument* _tmp0_;
#line 213 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 213 "../gxml/XNode.vala"
	_tmp0_ = self->_doc;
#line 213 "../gxml/XNode.vala"
	result = (GXmlDomDocument*) _tmp0_;
#line 213 "../gxml/XNode.vala"
	return result;
#line 1400 "XNode.c"
}

static void
gxml_xnode_real_set_owner_document (GXmlDomNode* base,
                                    GXmlDomDocument* value)
{
	GXmlXNode* self;
	GXmlXDocument* _tmp0_;
#line 214 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 214 "../gxml/XNode.vala"
	_tmp0_ = _g_object_ref0 (GXML_IS_XDOCUMENT (value) ? ((GXmlXDocument*) value) : NULL);
#line 214 "../gxml/XNode.vala"
	_g_object_unref0 (self->_doc);
#line 214 "../gxml/XNode.vala"
	self->_doc = _tmp0_;
#line 214 "../gxml/XNode.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_xnode_properties[GXML_XNODE_OWNER_DOCUMENT_PROPERTY]);
#line 1419 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_get_parent_node (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlXNode* self;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
#line 216 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 216 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_parent (self);
#line 216 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 216 "../gxml/XNode.vala"
	_tmp2_ = GXML_IS_DOM_NODE (_tmp1_) ? ((GXmlDomNode*) _tmp1_) : NULL;
#line 216 "../gxml/XNode.vala"
	if (_tmp2_ == NULL) {
#line 216 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp1_);
#line 1442 "XNode.c"
	}
#line 216 "../gxml/XNode.vala"
	result = _tmp2_;
#line 216 "../gxml/XNode.vala"
	return result;
#line 1448 "XNode.c"
}

static GXmlDomElement*
gxml_xnode_real_get_parent_element (GXmlDomNode* base)
{
	GXmlDomElement* result;
	GXmlXNode* self;
	GXmlDomElement* nullnode = NULL;
	GXmlDomNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	gboolean _tmp3_;
#line 218 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 219 "../gxml/XNode.vala"
	nullnode = NULL;
#line 220 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_parent (self);
#line 220 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 220 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 220 "../gxml/XNode.vala"
	_tmp3_ = GXML_IS_DOM_ELEMENT (_tmp2_);
#line 220 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp2_);
#line 220 "../gxml/XNode.vala"
	if (_tmp3_) {
#line 1477 "XNode.c"
		GXmlDomNode* _tmp4_;
		GXmlDomNode* _tmp5_;
		GXmlDomElement* _tmp6_;
#line 220 "../gxml/XNode.vala"
		_tmp4_ = gxml_xnode_get_parent (self);
#line 220 "../gxml/XNode.vala"
		_tmp5_ = _tmp4_;
#line 220 "../gxml/XNode.vala"
		_tmp6_ = GXML_IS_DOM_ELEMENT (_tmp5_) ? ((GXmlDomElement*) _tmp5_) : NULL;
#line 220 "../gxml/XNode.vala"
		if (_tmp6_ == NULL) {
#line 220 "../gxml/XNode.vala"
			_g_object_unref0 (_tmp5_);
#line 1491 "XNode.c"
		}
#line 220 "../gxml/XNode.vala"
		result = _tmp6_;
#line 220 "../gxml/XNode.vala"
		_g_object_unref0 (nullnode);
#line 220 "../gxml/XNode.vala"
		return result;
#line 1499 "XNode.c"
	}
#line 221 "../gxml/XNode.vala"
	result = nullnode;
#line 221 "../gxml/XNode.vala"
	return result;
#line 1505 "XNode.c"
}

static GXmlDomNodeList*
gxml_xnode_real_get_child_nodes (GXmlDomNode* base)
{
	GXmlDomNodeList* result;
	GXmlXNode* self;
	GeeBidirList* _tmp0_;
	GeeBidirList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
#line 224 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 224 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_children_nodes (self);
#line 224 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 224 "../gxml/XNode.vala"
	_tmp2_ = GXML_IS_DOM_NODE_LIST (_tmp1_) ? ((GXmlDomNodeList*) _tmp1_) : NULL;
#line 224 "../gxml/XNode.vala"
	if (_tmp2_ == NULL) {
#line 224 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp1_);
#line 1528 "XNode.c"
	}
#line 224 "../gxml/XNode.vala"
	result = _tmp2_;
#line 224 "../gxml/XNode.vala"
	return result;
#line 1534 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_get_first_child (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlXNode* self;
	GeeBidirList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	gpointer _tmp3_;
	GXmlDomNode* _tmp4_;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
#line 225 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 225 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_children_nodes (self);
#line 225 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 225 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 225 "../gxml/XNode.vala"
	_tmp3_ = gee_list_first ((GeeList*) _tmp2_);
#line 225 "../gxml/XNode.vala"
	_tmp4_ = (GXmlDomNode*) _tmp3_;
#line 225 "../gxml/XNode.vala"
	_tmp5_ = GXML_IS_DOM_NODE (_tmp4_) ? ((GXmlDomNode*) _tmp4_) : NULL;
#line 225 "../gxml/XNode.vala"
	if (_tmp5_ == NULL) {
#line 225 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp4_);
#line 1567 "XNode.c"
	}
#line 225 "../gxml/XNode.vala"
	_tmp6_ = _tmp5_;
#line 225 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp2_);
#line 225 "../gxml/XNode.vala"
	result = _tmp6_;
#line 225 "../gxml/XNode.vala"
	return result;
#line 1577 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_get_last_child (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlXNode* self;
	GeeBidirList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	gpointer _tmp3_;
	GXmlDomNode* _tmp4_;
	GXmlDomNode* _tmp5_;
	GXmlDomNode* _tmp6_;
#line 226 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 226 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_children_nodes (self);
#line 226 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 226 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 226 "../gxml/XNode.vala"
	_tmp3_ = gee_list_last ((GeeList*) _tmp2_);
#line 226 "../gxml/XNode.vala"
	_tmp4_ = (GXmlDomNode*) _tmp3_;
#line 226 "../gxml/XNode.vala"
	_tmp5_ = GXML_IS_DOM_NODE (_tmp4_) ? ((GXmlDomNode*) _tmp4_) : NULL;
#line 226 "../gxml/XNode.vala"
	if (_tmp5_ == NULL) {
#line 226 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp4_);
#line 1610 "XNode.c"
	}
#line 226 "../gxml/XNode.vala"
	_tmp6_ = _tmp5_;
#line 226 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp2_);
#line 226 "../gxml/XNode.vala"
	result = _tmp6_;
#line 226 "../gxml/XNode.vala"
	return result;
#line 1620 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_get_previous_sibling (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	xmlNode* _tmp2_;
	GXmlXDocument* _tmp3_;
	xmlNode* _tmp4_;
	xmlNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
#line 228 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 229 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 229 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 229 "../gxml/XNode.vala"
		result = NULL;
#line 229 "../gxml/XNode.vala"
		return result;
#line 1646 "XNode.c"
	}
#line 230 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 230 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_->prev;
#line 230 "../gxml/XNode.vala"
	if (_tmp2_ == NULL) {
#line 230 "../gxml/XNode.vala"
		result = NULL;
#line 230 "../gxml/XNode.vala"
		return result;
#line 1658 "XNode.c"
	}
#line 231 "../gxml/XNode.vala"
	_tmp3_ = self->_doc;
#line 231 "../gxml/XNode.vala"
	_tmp4_ = self->_node;
#line 231 "../gxml/XNode.vala"
	_tmp5_ = _tmp4_->prev;
#line 231 "../gxml/XNode.vala"
	_tmp6_ = gxml_xnode_to_gnode (_tmp3_, _tmp5_, FALSE);
#line 231 "../gxml/XNode.vala"
	_tmp7_ = GXML_IS_DOM_NODE (_tmp6_) ? ((GXmlDomNode*) _tmp6_) : NULL;
#line 231 "../gxml/XNode.vala"
	if (_tmp7_ == NULL) {
#line 231 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp6_);
#line 1674 "XNode.c"
	}
#line 231 "../gxml/XNode.vala"
	result = _tmp7_;
#line 231 "../gxml/XNode.vala"
	return result;
#line 1680 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_get_next_sibling (GXmlDomNode* base)
{
	GXmlDomNode* result;
	GXmlXNode* self;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	xmlNode* _tmp2_;
	GXmlXDocument* _tmp3_;
	xmlNode* _tmp4_;
	xmlNode* _tmp5_;
	GXmlDomNode* _tmp6_;
	GXmlDomNode* _tmp7_;
#line 235 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 236 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 236 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 236 "../gxml/XNode.vala"
		result = NULL;
#line 236 "../gxml/XNode.vala"
		return result;
#line 1706 "XNode.c"
	}
#line 237 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 237 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_->next;
#line 237 "../gxml/XNode.vala"
	if (_tmp2_ == NULL) {
#line 237 "../gxml/XNode.vala"
		result = NULL;
#line 237 "../gxml/XNode.vala"
		return result;
#line 1718 "XNode.c"
	}
#line 238 "../gxml/XNode.vala"
	_tmp3_ = self->_doc;
#line 238 "../gxml/XNode.vala"
	_tmp4_ = self->_node;
#line 238 "../gxml/XNode.vala"
	_tmp5_ = _tmp4_->next;
#line 238 "../gxml/XNode.vala"
	_tmp6_ = gxml_xnode_to_gnode (_tmp3_, _tmp5_, FALSE);
#line 238 "../gxml/XNode.vala"
	_tmp7_ = GXML_IS_DOM_NODE (_tmp6_) ? ((GXmlDomNode*) _tmp6_) : NULL;
#line 238 "../gxml/XNode.vala"
	if (_tmp7_ == NULL) {
#line 238 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp6_);
#line 1734 "XNode.c"
	}
#line 238 "../gxml/XNode.vala"
	result = _tmp7_;
#line 238 "../gxml/XNode.vala"
	return result;
#line 1740 "XNode.c"
}

static gchar*
gxml_xnode_real_get_node_value (GXmlDomNode* base)
{
	gchar* result;
	GXmlXNode* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 242 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 242 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_value (self);
#line 242 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 242 "../gxml/XNode.vala"
	result = _tmp1_;
#line 242 "../gxml/XNode.vala"
	return result;
#line 1760 "XNode.c"
}

static void
gxml_xnode_real_set_node_value (GXmlDomNode* base,
                                const gchar* value)
{
	GXmlXNode* self;
#line 242 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 242 "../gxml/XNode.vala"
	gxml_xnode_set_value (self, value);
#line 242 "../gxml/XNode.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_xnode_properties[GXML_XNODE_NODE_VALUE_PROPERTY]);
#line 1774 "XNode.c"
}

static gchar*
gxml_xnode_real_get_text_content (GXmlDomNode* base)
{
	gchar* result;
	GXmlXNode* self;
	gchar* t = NULL;
	gboolean _tmp6_ = FALSE;
#line 244 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 245 "../gxml/XNode.vala"
	t = NULL;
#line 246 "../gxml/XNode.vala"
	if (GXML_IS_DOM_TEXT (self)) {
#line 1790 "XNode.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 246 "../gxml/XNode.vala"
		_tmp0_ = gxml_dom_character_data_get_data ((GXmlDomCharacterData*) G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_TEXT, GXmlDomText));
#line 246 "../gxml/XNode.vala"
		_tmp1_ = _tmp0_;
#line 246 "../gxml/XNode.vala"
		result = _tmp1_;
#line 246 "../gxml/XNode.vala"
		_g_free0 (t);
#line 246 "../gxml/XNode.vala"
		return result;
#line 1803 "XNode.c"
	}
#line 247 "../gxml/XNode.vala"
	if (GXML_IS_DOM_PROCESSING_INSTRUCTION (self)) {
#line 1807 "XNode.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 247 "../gxml/XNode.vala"
		_tmp2_ = gxml_xnode_get_value (self);
#line 247 "../gxml/XNode.vala"
		_tmp3_ = _tmp2_;
#line 247 "../gxml/XNode.vala"
		result = _tmp3_;
#line 247 "../gxml/XNode.vala"
		_g_free0 (t);
#line 247 "../gxml/XNode.vala"
		return result;
#line 1820 "XNode.c"
	}
#line 248 "../gxml/XNode.vala"
	if (GXML_IS_DOM_COMMENT (self)) {
#line 1824 "XNode.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 248 "../gxml/XNode.vala"
		_tmp4_ = gxml_xnode_get_value (self);
#line 248 "../gxml/XNode.vala"
		_tmp5_ = _tmp4_;
#line 248 "../gxml/XNode.vala"
		result = _tmp5_;
#line 248 "../gxml/XNode.vala"
		_g_free0 (t);
#line 248 "../gxml/XNode.vala"
		return result;
#line 1837 "XNode.c"
	}
#line 249 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 249 "../gxml/XNode.vala"
		_tmp6_ = TRUE;
#line 1843 "XNode.c"
	} else {
#line 249 "../gxml/XNode.vala"
		_tmp6_ = GXML_IS_DOM_ELEMENT (self);
#line 1847 "XNode.c"
	}
#line 249 "../gxml/XNode.vala"
	if (_tmp6_) {
#line 1851 "XNode.c"
		{
			GeeBidirList* _n_list = NULL;
			GeeBidirList* _tmp7_;
			GeeBidirList* _tmp8_;
			gint _n_size = 0;
			GeeBidirList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _n_index = 0;
#line 250 "../gxml/XNode.vala"
			_tmp7_ = gxml_xnode_get_children_nodes (self);
#line 250 "../gxml/XNode.vala"
			_tmp8_ = _tmp7_;
#line 250 "../gxml/XNode.vala"
			_n_list = _tmp8_;
#line 250 "../gxml/XNode.vala"
			_tmp9_ = _n_list;
#line 250 "../gxml/XNode.vala"
			_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 250 "../gxml/XNode.vala"
			_tmp11_ = _tmp10_;
#line 250 "../gxml/XNode.vala"
			_n_size = _tmp11_;
#line 250 "../gxml/XNode.vala"
			_n_index = -1;
#line 250 "../gxml/XNode.vala"
			while (TRUE) {
#line 1879 "XNode.c"
				gint _tmp12_;
				gint _tmp13_;
				GXmlDomNode* n = NULL;
				GeeBidirList* _tmp14_;
				gpointer _tmp15_;
				GXmlDomNode* _tmp16_;
#line 250 "../gxml/XNode.vala"
				_n_index = _n_index + 1;
#line 250 "../gxml/XNode.vala"
				_tmp12_ = _n_index;
#line 250 "../gxml/XNode.vala"
				_tmp13_ = _n_size;
#line 250 "../gxml/XNode.vala"
				if (!(_tmp12_ < _tmp13_)) {
#line 250 "../gxml/XNode.vala"
					break;
#line 1896 "XNode.c"
				}
#line 250 "../gxml/XNode.vala"
				_tmp14_ = _n_list;
#line 250 "../gxml/XNode.vala"
				_tmp15_ = gee_list_get ((GeeList*) _tmp14_, _n_index);
#line 250 "../gxml/XNode.vala"
				n = (GXmlDomNode*) _tmp15_;
#line 251 "../gxml/XNode.vala"
				_tmp16_ = n;
#line 251 "../gxml/XNode.vala"
				if (GXML_IS_DOM_TEXT (_tmp16_)) {
#line 1908 "XNode.c"
					const gchar* _tmp17_;
#line 252 "../gxml/XNode.vala"
					_tmp17_ = t;
#line 252 "../gxml/XNode.vala"
					if (_tmp17_ == NULL) {
#line 1914 "XNode.c"
						GXmlDomNode* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
#line 252 "../gxml/XNode.vala"
						_tmp18_ = n;
#line 252 "../gxml/XNode.vala"
						_tmp19_ = gxml_xnode_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GXML_TYPE_XNODE, GXmlXNode));
#line 252 "../gxml/XNode.vala"
						_tmp20_ = _tmp19_;
#line 252 "../gxml/XNode.vala"
						_g_free0 (t);
#line 252 "../gxml/XNode.vala"
						t = _tmp20_;
#line 1928 "XNode.c"
					} else {
						const gchar* _tmp21_;
						GXmlDomNode* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
#line 253 "../gxml/XNode.vala"
						_tmp21_ = t;
#line 253 "../gxml/XNode.vala"
						_tmp22_ = n;
#line 253 "../gxml/XNode.vala"
						_tmp23_ = gxml_xnode_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GXML_TYPE_XNODE, GXmlXNode));
#line 253 "../gxml/XNode.vala"
						_tmp24_ = _tmp23_;
#line 253 "../gxml/XNode.vala"
						_tmp25_ = _tmp24_;
#line 253 "../gxml/XNode.vala"
						_tmp26_ = g_strconcat (_tmp21_, _tmp25_, NULL);
#line 253 "../gxml/XNode.vala"
						_g_free0 (t);
#line 253 "../gxml/XNode.vala"
						t = _tmp26_;
#line 253 "../gxml/XNode.vala"
						_g_free0 (_tmp25_);
#line 1954 "XNode.c"
					}
				}
#line 250 "../gxml/XNode.vala"
				_g_object_unref0 (n);
#line 1959 "XNode.c"
			}
#line 250 "../gxml/XNode.vala"
			_g_object_unref0 (_n_list);
#line 1963 "XNode.c"
		}
	}
#line 257 "../gxml/XNode.vala"
	result = t;
#line 257 "../gxml/XNode.vala"
	return result;
#line 1970 "XNode.c"
}

static void
gxml_xnode_real_set_text_content (GXmlDomNode* base,
                                  const gchar* value)
{
	GXmlXNode* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 259 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 260 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 260 "../gxml/XNode.vala"
		_tmp0_ = TRUE;
#line 1988 "XNode.c"
	} else {
#line 260 "../gxml/XNode.vala"
		_tmp0_ = GXML_IS_DOM_ELEMENT (self);
#line 1992 "XNode.c"
	}
#line 260 "../gxml/XNode.vala"
	if (_tmp0_) {
#line 1996 "XNode.c"
		{
			GXmlDomText* t = NULL;
			GXmlDomDocument* _tmp1_;
			GXmlDomDocument* _tmp2_;
			GXmlDomText* _tmp3_;
			GXmlDomDocument* _tmp4_;
			GXmlDomDocument* _tmp5_;
			GXmlDomNodeList* _tmp6_;
			GXmlDomNodeList* _tmp7_;
			GXmlDomNodeList* _tmp8_;
			GXmlDomText* _tmp9_;
#line 262 "../gxml/XNode.vala"
			_tmp1_ = gxml_xnode_get_document (self);
#line 262 "../gxml/XNode.vala"
			_tmp2_ = _tmp1_;
#line 262 "../gxml/XNode.vala"
			_tmp3_ = gxml_dom_document_create_text_node (_tmp2_, value, &_inner_error0_);
#line 262 "../gxml/XNode.vala"
			t = _tmp3_;
#line 262 "../gxml/XNode.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2018 "XNode.c"
				goto __catch0_g_error;
			}
#line 263 "../gxml/XNode.vala"
			_tmp4_ = gxml_xnode_get_document (self);
#line 263 "../gxml/XNode.vala"
			_tmp5_ = _tmp4_;
#line 263 "../gxml/XNode.vala"
			_tmp6_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) _tmp5_);
#line 263 "../gxml/XNode.vala"
			_tmp7_ = _tmp6_;
#line 263 "../gxml/XNode.vala"
			_tmp8_ = _tmp7_;
#line 263 "../gxml/XNode.vala"
			_tmp9_ = t;
#line 263 "../gxml/XNode.vala"
			gee_collection_add ((GeeCollection*) _tmp8_, (GXmlDomNode*) _tmp9_);
#line 263 "../gxml/XNode.vala"
			_g_object_unref0 (_tmp8_);
#line 261 "../gxml/XNode.vala"
			_g_object_unref0 (t);
#line 2039 "XNode.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 261 "../gxml/XNode.vala"
			e = _inner_error0_;
#line 261 "../gxml/XNode.vala"
			_inner_error0_ = NULL;
#line 265 "../gxml/XNode.vala"
			_tmp10_ = e;
#line 265 "../gxml/XNode.vala"
			_tmp11_ = _tmp10_->message;
#line 265 "../gxml/XNode.vala"
			g_warning (_ ("Error while setting text content to node: %s"), _tmp11_);
#line 261 "../gxml/XNode.vala"
			_g_error_free0 (e);
#line 2059 "XNode.c"
		}
		__finally0:
#line 261 "../gxml/XNode.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../gxml/XNode.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../gxml/XNode.vala"
			g_clear_error (&_inner_error0_);
#line 261 "../gxml/XNode.vala"
			return;
#line 2070 "XNode.c"
		}
	}
#line 268 "../gxml/XNode.vala"
	if (GXML_IS_DOM_TEXT (self)) {
#line 268 "../gxml/XNode.vala"
		_tmp13_ = TRUE;
#line 2077 "XNode.c"
	} else {
#line 268 "../gxml/XNode.vala"
		_tmp13_ = GXML_IS_DOM_COMMENT (self);
#line 2081 "XNode.c"
	}
#line 268 "../gxml/XNode.vala"
	if (_tmp13_) {
#line 268 "../gxml/XNode.vala"
		_tmp12_ = TRUE;
#line 2087 "XNode.c"
	} else {
#line 268 "../gxml/XNode.vala"
		_tmp12_ = GXML_IS_DOM_PROCESSING_INSTRUCTION (self);
#line 2091 "XNode.c"
	}
#line 268 "../gxml/XNode.vala"
	if (!_tmp12_) {
#line 268 "../gxml/XNode.vala"
		return;
#line 2097 "XNode.c"
	}
#line 269 "../gxml/XNode.vala"
	gxml_xnode_set_value (self, value);
#line 259 "../gxml/XNode.vala"
	g_object_notify_by_pspec ((GObject *) self, gxml_xnode_properties[GXML_XNODE_TEXT_CONTENT_PROPERTY]);
#line 2103 "XNode.c"
}

static gboolean
gxml_xnode_real_has_child_nodes (GXmlDomNode* base)
{
	GXmlXNode * self;
	GeeBidirList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 273 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 273 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_children_nodes (self);
#line 273 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 273 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 273 "../gxml/XNode.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 273 "../gxml/XNode.vala"
	_tmp4_ = _tmp3_;
#line 273 "../gxml/XNode.vala"
	_tmp5_ = _tmp4_ > 0;
#line 273 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp2_);
#line 273 "../gxml/XNode.vala"
	result = _tmp5_;
#line 273 "../gxml/XNode.vala"
	return result;
#line 2137 "XNode.c"
}

static void
gxml_xnode_real_normalize (GXmlDomNode* base)
{
	GXmlXNode * self;
#line 274 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 2146 "XNode.c"
	{
		gint i = 0;
#line 275 "../gxml/XNode.vala"
		i = 0;
#line 2151 "XNode.c"
		{
			gboolean _tmp0_ = FALSE;
#line 275 "../gxml/XNode.vala"
			_tmp0_ = TRUE;
#line 275 "../gxml/XNode.vala"
			while (TRUE) {
#line 2158 "XNode.c"
				GeeBidirList* _tmp2_;
				GeeBidirList* _tmp3_;
				GeeBidirList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gboolean _tmp7_;
				GXmlDomNode* n = NULL;
				GeeBidirList* _tmp8_;
				GeeBidirList* _tmp9_;
				GeeBidirList* _tmp10_;
				gpointer _tmp11_;
				GXmlDomNode* _tmp12_;
				GXmlDomNode* _tmp13_;
#line 275 "../gxml/XNode.vala"
				if (!_tmp0_) {
#line 2174 "XNode.c"
					gint _tmp1_;
#line 275 "../gxml/XNode.vala"
					_tmp1_ = i;
#line 275 "../gxml/XNode.vala"
					i = _tmp1_ + 1;
#line 2180 "XNode.c"
				}
#line 275 "../gxml/XNode.vala"
				_tmp0_ = FALSE;
#line 275 "../gxml/XNode.vala"
				_tmp2_ = gxml_xnode_get_children_nodes (self);
#line 275 "../gxml/XNode.vala"
				_tmp3_ = _tmp2_;
#line 275 "../gxml/XNode.vala"
				_tmp4_ = _tmp3_;
#line 275 "../gxml/XNode.vala"
				_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 275 "../gxml/XNode.vala"
				_tmp6_ = _tmp5_;
#line 275 "../gxml/XNode.vala"
				_tmp7_ = !(i < _tmp6_);
#line 275 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp4_);
#line 275 "../gxml/XNode.vala"
				if (_tmp7_) {
#line 275 "../gxml/XNode.vala"
					break;
#line 2202 "XNode.c"
				}
#line 276 "../gxml/XNode.vala"
				_tmp8_ = gxml_xnode_get_children_nodes (self);
#line 276 "../gxml/XNode.vala"
				_tmp9_ = _tmp8_;
#line 276 "../gxml/XNode.vala"
				_tmp10_ = _tmp9_;
#line 276 "../gxml/XNode.vala"
				_tmp11_ = gee_list_get ((GeeList*) _tmp10_, i);
#line 276 "../gxml/XNode.vala"
				_tmp12_ = (GXmlDomNode*) _tmp11_;
#line 276 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp10_);
#line 276 "../gxml/XNode.vala"
				n = _tmp12_;
#line 277 "../gxml/XNode.vala"
				_tmp13_ = n;
#line 277 "../gxml/XNode.vala"
				if (GXML_IS_DOM_TEXT (_tmp13_)) {
#line 2222 "XNode.c"
					GXmlDomNodeList* _tmp14_;
					GXmlDomNodeList* _tmp15_;
					GXmlDomNodeList* _tmp16_;
					gpointer _tmp17_;
					GXmlDomNode* _tmp18_;
#line 278 "../gxml/XNode.vala"
					_tmp14_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 278 "../gxml/XNode.vala"
					_tmp15_ = _tmp14_;
#line 278 "../gxml/XNode.vala"
					_tmp16_ = _tmp15_;
#line 278 "../gxml/XNode.vala"
					_tmp17_ = gee_list_remove_at ((GeeList*) _tmp16_, i);
#line 278 "../gxml/XNode.vala"
					_tmp18_ = (GXmlDomNode*) _tmp17_;
#line 278 "../gxml/XNode.vala"
					_g_object_unref0 (_tmp18_);
#line 278 "../gxml/XNode.vala"
					_g_object_unref0 (_tmp16_);
#line 2242 "XNode.c"
				}
#line 275 "../gxml/XNode.vala"
				_g_object_unref0 (n);
#line 2246 "XNode.c"
			}
		}
	}
}

GXmlDomNode*
gxml_xnode_clone_node (GXmlXNode* self,
                       gboolean deep)
{
	GXmlDomNode* nullnode = NULL;
	xmlNode* n = NULL;
	xmlNode* _tmp4_;
	GXmlXDocument* _tmp5_;
	xmlNode* _tmp6_;
	GXmlDomNode* _tmp7_;
	GXmlDomNode* result;
#line 283 "../gxml/XNode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 284 "../gxml/XNode.vala"
	nullnode = NULL;
#line 285 "../gxml/XNode.vala"
	n = NULL;
#line 286 "../gxml/XNode.vala"
	if (deep) {
#line 2271 "XNode.c"
		xmlNode* _tmp0_;
		xmlNode* _tmp1_;
#line 287 "../gxml/XNode.vala"
		_tmp0_ = self->_node;
#line 287 "../gxml/XNode.vala"
		_tmp1_ = xmlCopyNode (_tmp0_, 1);
#line 287 "../gxml/XNode.vala"
		n = _tmp1_;
#line 2280 "XNode.c"
	} else {
		xmlNode* _tmp2_;
		xmlNode* _tmp3_;
#line 289 "../gxml/XNode.vala"
		_tmp2_ = self->_node;
#line 289 "../gxml/XNode.vala"
		_tmp3_ = xmlCopyNode (_tmp2_, 2);
#line 289 "../gxml/XNode.vala"
		n = _tmp3_;
#line 2290 "XNode.c"
	}
#line 290 "../gxml/XNode.vala"
	_tmp4_ = n;
#line 290 "../gxml/XNode.vala"
	if (_tmp4_ == NULL) {
#line 290 "../gxml/XNode.vala"
		result = nullnode;
#line 290 "../gxml/XNode.vala"
		return result;
#line 2300 "XNode.c"
	}
#line 291 "../gxml/XNode.vala"
	_tmp5_ = self->_doc;
#line 291 "../gxml/XNode.vala"
	_tmp6_ = n;
#line 291 "../gxml/XNode.vala"
	_tmp7_ = gxml_xnode_to_gnode (_tmp5_, _tmp6_, TRUE);
#line 291 "../gxml/XNode.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GXML_TYPE_DOM_NODE, GXmlDomNode);
#line 291 "../gxml/XNode.vala"
	_g_object_unref0 (nullnode);
#line 291 "../gxml/XNode.vala"
	return result;
#line 2314 "XNode.c"
}

static gboolean
gxml_xnode_real_is_equal_node (GXmlDomNode* base,
                               GXmlDomNode* node)
{
	GXmlXNode * self;
	GeeBidirList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GXmlDomNodeList* _tmp5_;
	GXmlDomNodeList* _tmp6_;
	GXmlDomNodeList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean _tmp10_;
	gboolean result;
#line 293 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 294 "../gxml/XNode.vala"
	if (!GXML_IS_DOM_NODE (node)) {
#line 294 "../gxml/XNode.vala"
		result = FALSE;
#line 294 "../gxml/XNode.vala"
		return result;
#line 2342 "XNode.c"
	}
#line 295 "../gxml/XNode.vala"
	if (node == NULL) {
#line 295 "../gxml/XNode.vala"
		result = FALSE;
#line 295 "../gxml/XNode.vala"
		return result;
#line 2350 "XNode.c"
	}
#line 296 "../gxml/XNode.vala"
	_tmp0_ = gxml_xnode_get_children_nodes (self);
#line 296 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 296 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 296 "../gxml/XNode.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 296 "../gxml/XNode.vala"
	_tmp4_ = _tmp3_;
#line 296 "../gxml/XNode.vala"
	_tmp5_ = gxml_dom_node_get_child_nodes (node);
#line 296 "../gxml/XNode.vala"
	_tmp6_ = _tmp5_;
#line 296 "../gxml/XNode.vala"
	_tmp7_ = _tmp6_;
#line 296 "../gxml/XNode.vala"
	_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
#line 296 "../gxml/XNode.vala"
	_tmp9_ = _tmp8_;
#line 296 "../gxml/XNode.vala"
	_tmp10_ = _tmp4_ != _tmp9_;
#line 296 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp7_);
#line 296 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp2_);
#line 296 "../gxml/XNode.vala"
	if (_tmp10_) {
#line 296 "../gxml/XNode.vala"
		result = FALSE;
#line 296 "../gxml/XNode.vala"
		return result;
#line 2384 "XNode.c"
	}
	{
		GeeIterator* _a_it = NULL;
		GeeMap* _tmp11_;
		GeeMap* _tmp12_;
		GeeMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
#line 297 "../gxml/XNode.vala"
		_tmp11_ = gxml_xnode_get_attrs (self);
#line 297 "../gxml/XNode.vala"
		_tmp12_ = _tmp11_;
#line 297 "../gxml/XNode.vala"
		_tmp13_ = _tmp12_;
#line 297 "../gxml/XNode.vala"
		_tmp14_ = gee_map_get_values (_tmp13_);
#line 297 "../gxml/XNode.vala"
		_tmp15_ = _tmp14_;
#line 297 "../gxml/XNode.vala"
		_tmp16_ = _tmp15_;
#line 297 "../gxml/XNode.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 297 "../gxml/XNode.vala"
		_tmp18_ = _tmp17_;
#line 297 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp16_);
#line 297 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp13_);
#line 297 "../gxml/XNode.vala"
		_a_it = _tmp18_;
#line 297 "../gxml/XNode.vala"
		while (TRUE) {
#line 2420 "XNode.c"
			GeeIterator* _tmp19_;
			GXmlDomNode* a = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			GeeMap* _tmp22_;
			GeeMap* _tmp23_;
			GeeMap* _tmp24_;
			GXmlDomNode* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gboolean _tmp29_;
			GXmlDomNode* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			GeeMap* _tmp34_;
			GeeMap* _tmp35_;
			GeeMap* _tmp36_;
			GXmlDomNode* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gpointer _tmp41_;
			GXmlXNode* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gboolean _tmp46_;
#line 297 "../gxml/XNode.vala"
			_tmp19_ = _a_it;
#line 297 "../gxml/XNode.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 297 "../gxml/XNode.vala"
				break;
#line 2456 "XNode.c"
			}
#line 297 "../gxml/XNode.vala"
			_tmp20_ = _a_it;
#line 297 "../gxml/XNode.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 297 "../gxml/XNode.vala"
			a = (GXmlDomNode*) _tmp21_;
#line 298 "../gxml/XNode.vala"
			_tmp22_ = gxml_xnode_get_attrs (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_XNODE, GXmlXNode));
#line 298 "../gxml/XNode.vala"
			_tmp23_ = _tmp22_;
#line 298 "../gxml/XNode.vala"
			_tmp24_ = _tmp23_;
#line 298 "../gxml/XNode.vala"
			_tmp25_ = a;
#line 298 "../gxml/XNode.vala"
			_tmp26_ = gxml_dom_node_get_node_name (_tmp25_);
#line 298 "../gxml/XNode.vala"
			_tmp27_ = _tmp26_;
#line 298 "../gxml/XNode.vala"
			_tmp28_ = _tmp27_;
#line 298 "../gxml/XNode.vala"
			_tmp29_ = !gee_map_has_key (_tmp24_, _tmp28_);
#line 298 "../gxml/XNode.vala"
			_g_free0 (_tmp28_);
#line 298 "../gxml/XNode.vala"
			_g_object_unref0 (_tmp24_);
#line 298 "../gxml/XNode.vala"
			if (_tmp29_) {
#line 298 "../gxml/XNode.vala"
				result = FALSE;
#line 298 "../gxml/XNode.vala"
				_g_object_unref0 (a);
#line 298 "../gxml/XNode.vala"
				_g_object_unref0 (_a_it);
#line 298 "../gxml/XNode.vala"
				return result;
#line 2494 "XNode.c"
			}
#line 299 "../gxml/XNode.vala"
			_tmp30_ = a;
#line 299 "../gxml/XNode.vala"
			_tmp31_ = gxml_xnode_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GXML_TYPE_XNODE, GXmlXNode));
#line 299 "../gxml/XNode.vala"
			_tmp32_ = _tmp31_;
#line 299 "../gxml/XNode.vala"
			_tmp33_ = _tmp32_;
#line 299 "../gxml/XNode.vala"
			_tmp34_ = gxml_xnode_get_attrs (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_XNODE, GXmlXNode));
#line 299 "../gxml/XNode.vala"
			_tmp35_ = _tmp34_;
#line 299 "../gxml/XNode.vala"
			_tmp36_ = _tmp35_;
#line 299 "../gxml/XNode.vala"
			_tmp37_ = a;
#line 299 "../gxml/XNode.vala"
			_tmp38_ = gxml_dom_node_get_node_name (_tmp37_);
#line 299 "../gxml/XNode.vala"
			_tmp39_ = _tmp38_;
#line 299 "../gxml/XNode.vala"
			_tmp40_ = _tmp39_;
#line 299 "../gxml/XNode.vala"
			_tmp41_ = gee_map_get (_tmp36_, _tmp40_);
#line 299 "../gxml/XNode.vala"
			_tmp42_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomNode*) _tmp41_, GXML_TYPE_XNODE, GXmlXNode);
#line 299 "../gxml/XNode.vala"
			_tmp43_ = gxml_xnode_get_value (_tmp42_);
#line 299 "../gxml/XNode.vala"
			_tmp44_ = _tmp43_;
#line 299 "../gxml/XNode.vala"
			_tmp45_ = _tmp44_;
#line 299 "../gxml/XNode.vala"
			_tmp46_ = g_strcmp0 (_tmp33_, _tmp45_) != 0;
#line 299 "../gxml/XNode.vala"
			_g_free0 (_tmp45_);
#line 299 "../gxml/XNode.vala"
			_g_object_unref0 (_tmp42_);
#line 299 "../gxml/XNode.vala"
			_g_free0 (_tmp40_);
#line 299 "../gxml/XNode.vala"
			_g_object_unref0 (_tmp36_);
#line 299 "../gxml/XNode.vala"
			_g_free0 (_tmp33_);
#line 299 "../gxml/XNode.vala"
			if (_tmp46_) {
#line 299 "../gxml/XNode.vala"
				result = FALSE;
#line 299 "../gxml/XNode.vala"
				_g_object_unref0 (a);
#line 299 "../gxml/XNode.vala"
				_g_object_unref0 (_a_it);
#line 299 "../gxml/XNode.vala"
				return result;
#line 2550 "XNode.c"
			}
#line 297 "../gxml/XNode.vala"
			_g_object_unref0 (a);
#line 2554 "XNode.c"
		}
#line 297 "../gxml/XNode.vala"
		_g_object_unref0 (_a_it);
#line 2558 "XNode.c"
	}
	{
		gint i = 0;
#line 301 "../gxml/XNode.vala"
		i = 0;
#line 2564 "XNode.c"
		{
			gboolean _tmp47_ = FALSE;
#line 301 "../gxml/XNode.vala"
			_tmp47_ = TRUE;
#line 301 "../gxml/XNode.vala"
			while (TRUE) {
#line 2571 "XNode.c"
				GeeBidirList* _tmp49_;
				GeeBidirList* _tmp50_;
				GeeBidirList* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				gboolean _tmp54_;
				GeeBidirList* _tmp55_;
				GeeBidirList* _tmp56_;
				GeeBidirList* _tmp57_;
				gpointer _tmp58_;
				GXmlDomNode* _tmp59_;
				GXmlDomNodeList* _tmp60_;
				GXmlDomNodeList* _tmp61_;
				GXmlDomNodeList* _tmp62_;
				gpointer _tmp63_;
				GXmlDomNode* _tmp64_;
				gboolean _tmp65_;
#line 301 "../gxml/XNode.vala"
				if (!_tmp47_) {
#line 2591 "XNode.c"
					gint _tmp48_;
#line 301 "../gxml/XNode.vala"
					_tmp48_ = i;
#line 301 "../gxml/XNode.vala"
					i = _tmp48_ + 1;
#line 2597 "XNode.c"
				}
#line 301 "../gxml/XNode.vala"
				_tmp47_ = FALSE;
#line 301 "../gxml/XNode.vala"
				_tmp49_ = gxml_xnode_get_children_nodes (self);
#line 301 "../gxml/XNode.vala"
				_tmp50_ = _tmp49_;
#line 301 "../gxml/XNode.vala"
				_tmp51_ = _tmp50_;
#line 301 "../gxml/XNode.vala"
				_tmp52_ = gee_collection_get_size ((GeeCollection*) _tmp51_);
#line 301 "../gxml/XNode.vala"
				_tmp53_ = _tmp52_;
#line 301 "../gxml/XNode.vala"
				_tmp54_ = !(i < _tmp53_);
#line 301 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp51_);
#line 301 "../gxml/XNode.vala"
				if (_tmp54_) {
#line 301 "../gxml/XNode.vala"
					break;
#line 2619 "XNode.c"
				}
#line 302 "../gxml/XNode.vala"
				_tmp55_ = gxml_xnode_get_children_nodes (self);
#line 302 "../gxml/XNode.vala"
				_tmp56_ = _tmp55_;
#line 302 "../gxml/XNode.vala"
				_tmp57_ = _tmp56_;
#line 302 "../gxml/XNode.vala"
				_tmp58_ = gee_list_get ((GeeList*) _tmp57_, i);
#line 302 "../gxml/XNode.vala"
				_tmp59_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomNode*) _tmp58_, GXML_TYPE_DOM_NODE, GXmlDomNode);
#line 302 "../gxml/XNode.vala"
				_tmp60_ = gxml_dom_node_get_child_nodes (G_TYPE_CHECK_INSTANCE_CAST (node, GXML_TYPE_DOM_NODE, GXmlDomNode));
#line 302 "../gxml/XNode.vala"
				_tmp61_ = _tmp60_;
#line 302 "../gxml/XNode.vala"
				_tmp62_ = _tmp61_;
#line 302 "../gxml/XNode.vala"
				_tmp63_ = gee_list_get ((GeeList*) _tmp62_, i);
#line 302 "../gxml/XNode.vala"
				_tmp64_ = (GXmlDomNode*) _tmp63_;
#line 302 "../gxml/XNode.vala"
				_tmp65_ = !gxml_dom_node_is_equal_node (_tmp59_, _tmp64_);
#line 302 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp64_);
#line 302 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp62_);
#line 302 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp59_);
#line 302 "../gxml/XNode.vala"
				_g_object_unref0 (_tmp57_);
#line 302 "../gxml/XNode.vala"
				if (_tmp65_) {
#line 302 "../gxml/XNode.vala"
					result = FALSE;
#line 302 "../gxml/XNode.vala"
					return result;
#line 2657 "XNode.c"
				}
			}
		}
	}
#line 304 "../gxml/XNode.vala"
	result = TRUE;
#line 304 "../gxml/XNode.vala"
	return result;
#line 2666 "XNode.c"
}

static GXmlDomNodeDocumentPosition
gxml_xnode_real_compare_document_position (GXmlDomNode* base,
                                           GXmlDomNode* other)
{
	GXmlXNode * self;
	gboolean _tmp0_ = FALSE;
	GXmlDomDocument* _tmp1_;
	GXmlDomDocument* _tmp2_;
	GXmlDomDocument* _tmp3_;
	GXmlDomDocument* _tmp4_;
	GXmlDomNode* _tmp8_;
	GXmlDomNode* _tmp9_;
	GXmlDomNode* _tmp10_;
	gboolean _tmp11_;
	GXmlDomNodeDocumentPosition result;
#line 307 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 307 "../gxml/XNode.vala"
	g_return_val_if_fail (other != NULL, 0U);
#line 308 "../gxml/XNode.vala"
	if ((GXML_IS_DOM_NODE (self) ? ((GXmlDomNode*) self) : NULL) == other) {
#line 308 "../gxml/XNode.vala"
		result = GXML_DOM_NODE_DOCUMENT_POSITION_NONE;
#line 308 "../gxml/XNode.vala"
		return result;
#line 2694 "XNode.c"
	}
#line 309 "../gxml/XNode.vala"
	_tmp1_ = gxml_xnode_get_document (self);
#line 309 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 309 "../gxml/XNode.vala"
	_tmp3_ = gxml_dom_node_get_owner_document (G_TYPE_CHECK_INSTANCE_CAST (other, GXML_TYPE_DOM_NODE, GXmlDomNode));
#line 309 "../gxml/XNode.vala"
	_tmp4_ = _tmp3_;
#line 309 "../gxml/XNode.vala"
	if (_tmp2_ != _tmp4_) {
#line 309 "../gxml/XNode.vala"
		_tmp0_ = TRUE;
#line 2708 "XNode.c"
	} else {
		GXmlDomNode* _tmp5_;
		GXmlDomNode* _tmp6_;
		GXmlDomNode* _tmp7_;
#line 309 "../gxml/XNode.vala"
		_tmp5_ = gxml_dom_node_get_parent_node (other);
#line 309 "../gxml/XNode.vala"
		_tmp6_ = _tmp5_;
#line 309 "../gxml/XNode.vala"
		_tmp7_ = _tmp6_;
#line 309 "../gxml/XNode.vala"
		_tmp0_ = _tmp7_ == NULL;
#line 309 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp7_);
#line 2723 "XNode.c"
	}
#line 309 "../gxml/XNode.vala"
	if (_tmp0_) {
#line 2727 "XNode.c"
		GXmlDomNodeDocumentPosition p = 0U;
#line 310 "../gxml/XNode.vala"
		p = GXML_DOM_NODE_DOCUMENT_POSITION_DISCONNECTED & GXML_DOM_NODE_DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC;
#line 311 "../gxml/XNode.vala"
		if ((&self) > (&other)) {
#line 312 "../gxml/XNode.vala"
			p = p & GXML_DOM_NODE_DOCUMENT_POSITION_PRECEDING;
#line 2735 "XNode.c"
		} else {
#line 314 "../gxml/XNode.vala"
			p = p & GXML_DOM_NODE_DOCUMENT_POSITION_FOLLOWING;
#line 2739 "XNode.c"
		}
#line 315 "../gxml/XNode.vala"
		result = p;
#line 315 "../gxml/XNode.vala"
		return result;
#line 2745 "XNode.c"
	}
#line 317 "../gxml/XNode.vala"
	if (gxml_dom_node_contains (G_TYPE_CHECK_INSTANCE_CAST (self, GXML_TYPE_DOM_NODE, GXmlDomNode), other)) {
#line 318 "../gxml/XNode.vala"
		result = GXML_DOM_NODE_DOCUMENT_POSITION_CONTAINED_BY & GXML_DOM_NODE_DOCUMENT_POSITION_FOLLOWING;
#line 318 "../gxml/XNode.vala"
		return result;
#line 2753 "XNode.c"
	}
#line 319 "../gxml/XNode.vala"
	_tmp8_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 319 "../gxml/XNode.vala"
	_tmp9_ = _tmp8_;
#line 319 "../gxml/XNode.vala"
	_tmp10_ = _tmp9_;
#line 319 "../gxml/XNode.vala"
	_tmp11_ = gxml_dom_node_contains (_tmp10_, other);
#line 319 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp10_);
#line 319 "../gxml/XNode.vala"
	if (_tmp11_) {
#line 2767 "XNode.c"
		GXmlDomNode* par = NULL;
		GXmlDomNode* _tmp12_;
		GXmlDomNode* _tmp13_;
		GXmlDomNode* _tmp14_;
		GXmlDomNodeList* _tmp15_;
		GXmlDomNodeList* _tmp16_;
		GXmlDomNodeList* _tmp17_;
		GXmlDomNode* _tmp18_;
		GXmlDomNodeList* _tmp19_;
		GXmlDomNodeList* _tmp20_;
		GXmlDomNodeList* _tmp21_;
		gboolean _tmp22_;
#line 320 "../gxml/XNode.vala"
		_tmp12_ = gxml_dom_node_get_parent_node ((GXmlDomNode*) self);
#line 320 "../gxml/XNode.vala"
		_tmp13_ = _tmp12_;
#line 320 "../gxml/XNode.vala"
		par = _tmp13_;
#line 321 "../gxml/XNode.vala"
		_tmp14_ = par;
#line 321 "../gxml/XNode.vala"
		_tmp15_ = gxml_dom_node_get_child_nodes (_tmp14_);
#line 321 "../gxml/XNode.vala"
		_tmp16_ = _tmp15_;
#line 321 "../gxml/XNode.vala"
		_tmp17_ = _tmp16_;
#line 321 "../gxml/XNode.vala"
		_tmp18_ = par;
#line 321 "../gxml/XNode.vala"
		_tmp19_ = gxml_dom_node_get_child_nodes (_tmp18_);
#line 321 "../gxml/XNode.vala"
		_tmp20_ = _tmp19_;
#line 321 "../gxml/XNode.vala"
		_tmp21_ = _tmp20_;
#line 321 "../gxml/XNode.vala"
		_tmp22_ = gee_list_index_of ((GeeList*) _tmp17_, (GXmlDomNode*) self) > gee_list_index_of ((GeeList*) _tmp21_, other);
#line 321 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp21_);
#line 321 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp17_);
#line 321 "../gxml/XNode.vala"
		if (_tmp22_) {
#line 322 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_DOCUMENT_POSITION_PRECEDING;
#line 322 "../gxml/XNode.vala"
			_g_object_unref0 (par);
#line 322 "../gxml/XNode.vala"
			return result;
#line 2816 "XNode.c"
		} else {
#line 324 "../gxml/XNode.vala"
			result = GXML_DOM_NODE_DOCUMENT_POSITION_FOLLOWING;
#line 324 "../gxml/XNode.vala"
			_g_object_unref0 (par);
#line 324 "../gxml/XNode.vala"
			return result;
#line 2824 "XNode.c"
		}
#line 319 "../gxml/XNode.vala"
		_g_object_unref0 (par);
#line 2828 "XNode.c"
	}
#line 326 "../gxml/XNode.vala"
	if (gxml_dom_node_contains (other, (GXmlDomNode*) self)) {
#line 327 "../gxml/XNode.vala"
		result = GXML_DOM_NODE_DOCUMENT_POSITION_CONTAINS & GXML_DOM_NODE_DOCUMENT_POSITION_PRECEDING;
#line 327 "../gxml/XNode.vala"
		return result;
#line 2836 "XNode.c"
	}
#line 328 "../gxml/XNode.vala"
	g_warning ("XNode.vala:328: %s", _ ("Can't find node position"));
#line 329 "../gxml/XNode.vala"
	result = GXML_DOM_NODE_DOCUMENT_POSITION_NONE;
#line 329 "../gxml/XNode.vala"
	return result;
#line 2844 "XNode.c"
}

static gboolean
gxml_xnode_real_contains (GXmlDomNode* base,
                          GXmlDomNode* other)
{
	GXmlXNode * self;
	GXmlDomNodeList* _tmp0_;
	GXmlDomNodeList* _tmp1_;
	GXmlDomNodeList* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 331 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 332 "../gxml/XNode.vala"
	if (other == NULL) {
#line 332 "../gxml/XNode.vala"
		result = FALSE;
#line 332 "../gxml/XNode.vala"
		return result;
#line 2865 "XNode.c"
	}
#line 333 "../gxml/XNode.vala"
	_tmp0_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 333 "../gxml/XNode.vala"
	_tmp1_ = _tmp0_;
#line 333 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 333 "../gxml/XNode.vala"
	_tmp3_ = gee_collection_contains ((GeeCollection*) _tmp2_, other);
#line 333 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp2_);
#line 333 "../gxml/XNode.vala"
	result = _tmp3_;
#line 333 "../gxml/XNode.vala"
	return result;
#line 2881 "XNode.c"
}

static gchar*
gxml_xnode_real_lookup_prefix (GXmlDomNode* base,
                               const gchar* nspace)
{
	GXmlXNode * self;
	xmlNode* _tmp0_;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	GXmlDomNode* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	xmlNs* ns = NULL;
	xmlNode* _tmp6_;
	xmlDoc* _tmp7_;
	xmlNode* _tmp8_;
	xmlNs* _tmp9_;
	xmlNs* _tmp10_;
	xmlNs* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
#line 336 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 337 "../gxml/XNode.vala"
	_tmp0_ = self->_node;
#line 337 "../gxml/XNode.vala"
	if (_tmp0_ == NULL) {
#line 337 "../gxml/XNode.vala"
		result = NULL;
#line 337 "../gxml/XNode.vala"
		return result;
#line 2915 "XNode.c"
	}
#line 338 "../gxml/XNode.vala"
	_tmp1_ = gxml_xnode_get_parent (self);
#line 338 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 338 "../gxml/XNode.vala"
	_tmp3_ = _tmp2_;
#line 338 "../gxml/XNode.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 338 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp3_);
#line 338 "../gxml/XNode.vala"
	if (_tmp4_) {
#line 338 "../gxml/XNode.vala"
		result = NULL;
#line 338 "../gxml/XNode.vala"
		return result;
#line 2933 "XNode.c"
	}
#line 339 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (self)) {
#line 339 "../gxml/XNode.vala"
		_tmp5_ = TRUE;
#line 2939 "XNode.c"
	} else {
#line 339 "../gxml/XNode.vala"
		_tmp5_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 2943 "XNode.c"
	}
#line 339 "../gxml/XNode.vala"
	if (_tmp5_) {
#line 339 "../gxml/XNode.vala"
		result = NULL;
#line 339 "../gxml/XNode.vala"
		return result;
#line 2951 "XNode.c"
	}
#line 340 "../gxml/XNode.vala"
	_tmp6_ = self->_node;
#line 340 "../gxml/XNode.vala"
	_tmp7_ = _tmp6_->doc;
#line 340 "../gxml/XNode.vala"
	_tmp8_ = self->_node;
#line 340 "../gxml/XNode.vala"
	_tmp9_ = xmlSearchNsByHref (_tmp7_, _tmp8_, nspace);
#line 340 "../gxml/XNode.vala"
	ns = _tmp9_;
#line 341 "../gxml/XNode.vala"
	_tmp10_ = ns;
#line 341 "../gxml/XNode.vala"
	if (_tmp10_ == NULL) {
#line 341 "../gxml/XNode.vala"
		result = NULL;
#line 341 "../gxml/XNode.vala"
		return result;
#line 2971 "XNode.c"
	}
#line 342 "../gxml/XNode.vala"
	_tmp11_ = ns;
#line 342 "../gxml/XNode.vala"
	_tmp12_ = _tmp11_->prefix;
#line 342 "../gxml/XNode.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 342 "../gxml/XNode.vala"
	result = _tmp13_;
#line 342 "../gxml/XNode.vala"
	return result;
#line 2983 "XNode.c"
}

static gchar*
gxml_xnode_real_lookup_namespace_uri (GXmlDomNode* base,
                                      const gchar* prefix)
{
	GXmlXNode * self;
	gboolean _tmp0_ = FALSE;
	xmlNs* ns = NULL;
	xmlNode* _tmp1_;
	xmlDoc* _tmp2_;
	xmlNode* _tmp3_;
	xmlNs* _tmp4_;
	xmlNs* _tmp5_;
	xmlNs* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 344 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 345 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT_TYPE (self)) {
#line 345 "../gxml/XNode.vala"
		_tmp0_ = TRUE;
#line 3008 "XNode.c"
	} else {
#line 345 "../gxml/XNode.vala"
		_tmp0_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 3012 "XNode.c"
	}
#line 345 "../gxml/XNode.vala"
	if (_tmp0_) {
#line 345 "../gxml/XNode.vala"
		result = NULL;
#line 345 "../gxml/XNode.vala"
		return result;
#line 3020 "XNode.c"
	}
#line 346 "../gxml/XNode.vala"
	_tmp1_ = self->_node;
#line 346 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_->doc;
#line 346 "../gxml/XNode.vala"
	_tmp3_ = self->_node;
#line 346 "../gxml/XNode.vala"
	_tmp4_ = xmlSearchNs (_tmp2_, _tmp3_, prefix);
#line 346 "../gxml/XNode.vala"
	ns = _tmp4_;
#line 347 "../gxml/XNode.vala"
	_tmp5_ = ns;
#line 347 "../gxml/XNode.vala"
	if (_tmp5_ == NULL) {
#line 347 "../gxml/XNode.vala"
		result = NULL;
#line 347 "../gxml/XNode.vala"
		return result;
#line 3040 "XNode.c"
	}
#line 348 "../gxml/XNode.vala"
	_tmp6_ = ns;
#line 348 "../gxml/XNode.vala"
	_tmp7_ = _tmp6_->href;
#line 348 "../gxml/XNode.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 348 "../gxml/XNode.vala"
	result = _tmp8_;
#line 348 "../gxml/XNode.vala"
	return result;
#line 3052 "XNode.c"
}

static gboolean
gxml_xnode_real_is_default_namespace (GXmlDomNode* base,
                                      const gchar* nspace)
{
	GXmlXNode * self;
	gchar* ns = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 350 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 351 "../gxml/XNode.vala"
	if (nspace == NULL) {
#line 351 "../gxml/XNode.vala"
		result = FALSE;
#line 351 "../gxml/XNode.vala"
		return result;
#line 3072 "XNode.c"
	}
#line 352 "../gxml/XNode.vala"
	_tmp0_ = gxml_dom_node_lookup_namespace_uri ((GXmlDomNode*) self, NULL);
#line 352 "../gxml/XNode.vala"
	ns = _tmp0_;
#line 353 "../gxml/XNode.vala"
	_tmp1_ = ns;
#line 353 "../gxml/XNode.vala"
	if (g_strcmp0 (_tmp1_, nspace) == 0) {
#line 353 "../gxml/XNode.vala"
		result = TRUE;
#line 353 "../gxml/XNode.vala"
		_g_free0 (ns);
#line 353 "../gxml/XNode.vala"
		return result;
#line 3088 "XNode.c"
	}
#line 354 "../gxml/XNode.vala"
	result = FALSE;
#line 354 "../gxml/XNode.vala"
	_g_free0 (ns);
#line 354 "../gxml/XNode.vala"
	return result;
#line 3096 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_insert_before (GXmlDomNode* base,
                               GXmlDomNode* node,
                               GXmlDomNode* child,
                               GError** error)
{
	GXmlXNode * self;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GeeBidirList* _tmp24_;
	GeeBidirList* _tmp25_;
	GeeBidirList* _tmp26_;
	GXmlDomNode* _tmp27_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result;
#line 357 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 357 "../gxml/XNode.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 358 "../gxml/XNode.vala"
	if (!GXML_IS_XNODE (node)) {
#line 3128 "XNode.c"
		GError* _tmp0_;
#line 359 "../gxml/XNode.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Invalid attempt to add invalid node type"));
#line 359 "../gxml/XNode.vala"
		_inner_error0_ = _tmp0_;
#line 359 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 359 "../gxml/XNode.vala"
		return NULL;
#line 3138 "XNode.c"
	}
#line 360 "../gxml/XNode.vala"
	if (child != NULL) {
#line 360 "../gxml/XNode.vala"
		_tmp1_ = !gxml_dom_node_contains ((GXmlDomNode*) self, child);
#line 3144 "XNode.c"
	} else {
#line 360 "../gxml/XNode.vala"
		_tmp1_ = FALSE;
#line 3148 "XNode.c"
	}
#line 360 "../gxml/XNode.vala"
	if (_tmp1_) {
#line 3152 "XNode.c"
		GError* _tmp2_;
#line 361 "../gxml/XNode.vala"
		_tmp2_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_FOUND_ERROR, _ ("Can't find child to insert node before"));
#line 361 "../gxml/XNode.vala"
		_inner_error0_ = _tmp2_;
#line 361 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 361 "../gxml/XNode.vala"
		return NULL;
#line 3162 "XNode.c"
	}
#line 362 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 362 "../gxml/XNode.vala"
		_tmp4_ = TRUE;
#line 3168 "XNode.c"
	} else {
#line 363 "../gxml/XNode.vala"
		_tmp4_ = GXML_IS_DOM_ELEMENT (self);
#line 3172 "XNode.c"
	}
#line 362 "../gxml/XNode.vala"
	if (_tmp4_) {
#line 362 "../gxml/XNode.vala"
		_tmp3_ = TRUE;
#line 3178 "XNode.c"
	} else {
#line 364 "../gxml/XNode.vala"
		_tmp3_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 3182 "XNode.c"
	}
#line 362 "../gxml/XNode.vala"
	if (!_tmp3_) {
#line 3186 "XNode.c"
		GError* _tmp5_;
#line 365 "../gxml/XNode.vala"
		_tmp5_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert a node"));
#line 365 "../gxml/XNode.vala"
		_inner_error0_ = _tmp5_;
#line 365 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 365 "../gxml/XNode.vala"
		return NULL;
#line 3196 "XNode.c"
	}
#line 366 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT_FRAGMENT (node)) {
#line 366 "../gxml/XNode.vala"
		_tmp10_ = TRUE;
#line 3202 "XNode.c"
	} else {
#line 367 "../gxml/XNode.vala"
		_tmp10_ = GXML_IS_DOM_DOCUMENT_TYPE (node);
#line 3206 "XNode.c"
	}
#line 366 "../gxml/XNode.vala"
	if (_tmp10_) {
#line 366 "../gxml/XNode.vala"
		_tmp9_ = TRUE;
#line 3212 "XNode.c"
	} else {
#line 368 "../gxml/XNode.vala"
		_tmp9_ = GXML_IS_DOM_ELEMENT (node);
#line 3216 "XNode.c"
	}
#line 366 "../gxml/XNode.vala"
	if (_tmp9_) {
#line 366 "../gxml/XNode.vala"
		_tmp8_ = TRUE;
#line 3222 "XNode.c"
	} else {
#line 369 "../gxml/XNode.vala"
		_tmp8_ = GXML_IS_DOM_TEXT (node);
#line 3226 "XNode.c"
	}
#line 366 "../gxml/XNode.vala"
	if (_tmp8_) {
#line 366 "../gxml/XNode.vala"
		_tmp7_ = TRUE;
#line 3232 "XNode.c"
	} else {
#line 370 "../gxml/XNode.vala"
		_tmp7_ = GXML_IS_DOM_PROCESSING_INSTRUCTION (node);
#line 3236 "XNode.c"
	}
#line 366 "../gxml/XNode.vala"
	if (_tmp7_) {
#line 366 "../gxml/XNode.vala"
		_tmp6_ = TRUE;
#line 3242 "XNode.c"
	} else {
#line 371 "../gxml/XNode.vala"
		_tmp6_ = GXML_IS_DOM_COMMENT (node);
#line 3246 "XNode.c"
	}
#line 366 "../gxml/XNode.vala"
	if (!_tmp6_) {
#line 3250 "XNode.c"
		GError* _tmp11_;
#line 372 "../gxml/XNode.vala"
		_tmp11_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert an invalid node type"));
#line 372 "../gxml/XNode.vala"
		_inner_error0_ = _tmp11_;
#line 372 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 372 "../gxml/XNode.vala"
		return NULL;
#line 3260 "XNode.c"
	}
#line 373 "../gxml/XNode.vala"
	if (GXML_IS_DOM_TEXT (node)) {
#line 373 "../gxml/XNode.vala"
		_tmp13_ = GXML_IS_DOM_DOCUMENT (self);
#line 3266 "XNode.c"
	} else {
#line 373 "../gxml/XNode.vala"
		_tmp13_ = FALSE;
#line 3270 "XNode.c"
	}
#line 373 "../gxml/XNode.vala"
	if (_tmp13_) {
#line 373 "../gxml/XNode.vala"
		_tmp12_ = TRUE;
#line 3276 "XNode.c"
	} else {
		gboolean _tmp14_ = FALSE;
#line 374 "../gxml/XNode.vala"
		if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 374 "../gxml/XNode.vala"
			_tmp14_ = !GXML_IS_DOM_DOCUMENT (self);
#line 3283 "XNode.c"
		} else {
#line 374 "../gxml/XNode.vala"
			_tmp14_ = FALSE;
#line 3287 "XNode.c"
		}
#line 374 "../gxml/XNode.vala"
		_tmp12_ = _tmp14_;
#line 3291 "XNode.c"
	}
#line 373 "../gxml/XNode.vala"
	if (_tmp12_) {
#line 3295 "XNode.c"
		GError* _tmp15_;
#line 375 "../gxml/XNode.vala"
		_tmp15_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to insert a document's type or text node to an invalid" \
" parent"));
#line 375 "../gxml/XNode.vala"
		_inner_error0_ = _tmp15_;
#line 375 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 375 "../gxml/XNode.vala"
		return NULL;
#line 3305 "XNode.c"
	}
#line 377 "../gxml/XNode.vala"
	if (child != NULL) {
#line 3309 "XNode.c"
		gint i = 0;
		GeeBidirList* _tmp16_;
		GeeBidirList* _tmp17_;
		GeeBidirList* _tmp18_;
		gint _tmp19_;
		GeeBidirList* _tmp20_;
		GeeBidirList* _tmp21_;
		GeeBidirList* _tmp22_;
		GXmlDomNode* _tmp23_;
#line 378 "../gxml/XNode.vala"
		_tmp16_ = gxml_xnode_get_children_nodes (self);
#line 378 "../gxml/XNode.vala"
		_tmp17_ = _tmp16_;
#line 378 "../gxml/XNode.vala"
		_tmp18_ = _tmp17_;
#line 378 "../gxml/XNode.vala"
		_tmp19_ = gee_list_index_of ((GeeList*) _tmp18_, GXML_IS_DOM_NODE (child) ? ((GXmlDomNode*) child) : NULL);
#line 378 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp18_);
#line 378 "../gxml/XNode.vala"
		i = _tmp19_;
#line 379 "../gxml/XNode.vala"
		_tmp20_ = gxml_xnode_get_children_nodes (self);
#line 379 "../gxml/XNode.vala"
		_tmp21_ = _tmp20_;
#line 379 "../gxml/XNode.vala"
		_tmp22_ = _tmp21_;
#line 379 "../gxml/XNode.vala"
		gee_list_insert ((GeeList*) _tmp22_, i, GXML_IS_DOM_NODE (node) ? ((GXmlDomNode*) node) : NULL);
#line 379 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp22_);
#line 380 "../gxml/XNode.vala"
		_tmp23_ = _g_object_ref0 (node);
#line 380 "../gxml/XNode.vala"
		result = _tmp23_;
#line 380 "../gxml/XNode.vala"
		return result;
#line 3347 "XNode.c"
	}
#line 382 "../gxml/XNode.vala"
	_tmp24_ = gxml_xnode_get_children_nodes (self);
#line 382 "../gxml/XNode.vala"
	_tmp25_ = _tmp24_;
#line 382 "../gxml/XNode.vala"
	_tmp26_ = _tmp25_;
#line 382 "../gxml/XNode.vala"
	gee_collection_add ((GeeCollection*) _tmp26_, GXML_IS_DOM_NODE (node) ? ((GXmlDomNode*) node) : NULL);
#line 382 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp26_);
#line 383 "../gxml/XNode.vala"
	_tmp27_ = _g_object_ref0 (node);
#line 383 "../gxml/XNode.vala"
	result = _tmp27_;
#line 383 "../gxml/XNode.vala"
	return result;
#line 3365 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_append_child (GXmlDomNode* base,
                              GXmlDomNode* node,
                              GError** error)
{
	GXmlXNode * self;
	GXmlDomNode* _tmp0_ = NULL;
	GXmlDomNode* _tmp1_;
	GXmlDomNode* _tmp2_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result;
#line 385 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 385 "../gxml/XNode.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 386 "../gxml/XNode.vala"
	_tmp1_ = gxml_dom_node_insert_before ((GXmlDomNode*) self, node, NULL, &_inner_error0_);
#line 386 "../gxml/XNode.vala"
	_tmp0_ = _tmp1_;
#line 386 "../gxml/XNode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 386 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 386 "../gxml/XNode.vala"
		return NULL;
#line 3393 "XNode.c"
	}
#line 386 "../gxml/XNode.vala"
	_tmp2_ = _tmp0_;
#line 386 "../gxml/XNode.vala"
	_tmp0_ = NULL;
#line 386 "../gxml/XNode.vala"
	result = _tmp2_;
#line 386 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp0_);
#line 386 "../gxml/XNode.vala"
	return result;
#line 3405 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_replace_child (GXmlDomNode* base,
                               GXmlDomNode* node,
                               GXmlDomNode* child,
                               GError** error)
{
	GXmlXNode * self;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gint i = 0;
	GeeBidirList* _tmp18_;
	GeeBidirList* _tmp19_;
	GeeBidirList* _tmp20_;
	gint _tmp21_;
	GXmlDomNode* rch = NULL;
	GeeBidirList* _tmp22_;
	GeeBidirList* _tmp23_;
	GeeBidirList* _tmp24_;
	gpointer _tmp25_;
	GXmlDomNode* _tmp26_;
	GeeBidirList* _tmp27_;
	GeeBidirList* _tmp28_;
	GeeBidirList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gboolean _tmp32_;
	GeeBidirList* _tmp36_;
	GeeBidirList* _tmp37_;
	GeeBidirList* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	gboolean _tmp41_;
	GXmlDomNode* _tmp45_;
	GXmlDomNode* _tmp46_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result;
#line 388 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 388 "../gxml/XNode.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 388 "../gxml/XNode.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 389 "../gxml/XNode.vala"
	if (!GXML_IS_XNODE (node)) {
#line 3460 "XNode.c"
		const gchar* _tmp0_;
		GError* _tmp1_;
#line 390 "../gxml/XNode.vala"
		_tmp0_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) node));
#line 390 "../gxml/XNode.vala"
		_tmp1_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_INVALID_NODE_TYPE_ERROR, _ ("Only GXml.XNode nodes are supported. Given a %s type"), _tmp0_);
#line 390 "../gxml/XNode.vala"
		_inner_error0_ = _tmp1_;
#line 390 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 390 "../gxml/XNode.vala"
		return NULL;
#line 3473 "XNode.c"
	}
#line 393 "../gxml/XNode.vala"
	if (child == NULL) {
#line 393 "../gxml/XNode.vala"
		_tmp2_ = TRUE;
#line 3479 "XNode.c"
	} else {
#line 393 "../gxml/XNode.vala"
		_tmp2_ = !gxml_dom_node_contains ((GXmlDomNode*) self, child);
#line 3483 "XNode.c"
	}
#line 393 "../gxml/XNode.vala"
	if (_tmp2_) {
#line 3487 "XNode.c"
		GError* _tmp3_;
#line 394 "../gxml/XNode.vala"
		_tmp3_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_FOUND_ERROR, _ ("Can't find child node to replace or child have a different parent"));
#line 394 "../gxml/XNode.vala"
		_inner_error0_ = _tmp3_;
#line 394 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 394 "../gxml/XNode.vala"
		return NULL;
#line 3497 "XNode.c"
	}
#line 397 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT (self)) {
#line 397 "../gxml/XNode.vala"
		_tmp5_ = TRUE;
#line 3503 "XNode.c"
	} else {
#line 398 "../gxml/XNode.vala"
		_tmp5_ = GXML_IS_DOM_ELEMENT (self);
#line 3507 "XNode.c"
	}
#line 397 "../gxml/XNode.vala"
	if (_tmp5_) {
#line 397 "../gxml/XNode.vala"
		_tmp4_ = TRUE;
#line 3513 "XNode.c"
	} else {
#line 399 "../gxml/XNode.vala"
		_tmp4_ = GXML_IS_DOM_DOCUMENT_FRAGMENT (self);
#line 3517 "XNode.c"
	}
#line 397 "../gxml/XNode.vala"
	if (!_tmp4_) {
#line 3521 "XNode.c"
		GError* _tmp6_;
#line 401 "../gxml/XNode.vala"
		_tmp6_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to replace a node on unsupported parent"));
#line 401 "../gxml/XNode.vala"
		_inner_error0_ = _tmp6_;
#line 401 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 401 "../gxml/XNode.vala"
		return NULL;
#line 3531 "XNode.c"
	}
#line 404 "../gxml/XNode.vala"
	if (GXML_IS_DOM_DOCUMENT_FRAGMENT (node)) {
#line 404 "../gxml/XNode.vala"
		_tmp11_ = TRUE;
#line 3537 "XNode.c"
	} else {
#line 405 "../gxml/XNode.vala"
		_tmp11_ = GXML_IS_DOM_DOCUMENT_TYPE (node);
#line 3541 "XNode.c"
	}
#line 404 "../gxml/XNode.vala"
	if (_tmp11_) {
#line 404 "../gxml/XNode.vala"
		_tmp10_ = TRUE;
#line 3547 "XNode.c"
	} else {
#line 406 "../gxml/XNode.vala"
		_tmp10_ = GXML_IS_DOM_ELEMENT (node);
#line 3551 "XNode.c"
	}
#line 404 "../gxml/XNode.vala"
	if (_tmp10_) {
#line 404 "../gxml/XNode.vala"
		_tmp9_ = TRUE;
#line 3557 "XNode.c"
	} else {
#line 407 "../gxml/XNode.vala"
		_tmp9_ = GXML_IS_DOM_TEXT (node);
#line 3561 "XNode.c"
	}
#line 404 "../gxml/XNode.vala"
	if (_tmp9_) {
#line 404 "../gxml/XNode.vala"
		_tmp8_ = TRUE;
#line 3567 "XNode.c"
	} else {
#line 408 "../gxml/XNode.vala"
		_tmp8_ = GXML_IS_DOM_PROCESSING_INSTRUCTION (node);
#line 3571 "XNode.c"
	}
#line 404 "../gxml/XNode.vala"
	if (_tmp8_) {
#line 404 "../gxml/XNode.vala"
		_tmp7_ = TRUE;
#line 3577 "XNode.c"
	} else {
#line 409 "../gxml/XNode.vala"
		_tmp7_ = GXML_IS_DOM_COMMENT (node);
#line 3581 "XNode.c"
	}
#line 404 "../gxml/XNode.vala"
	if (!_tmp7_) {
#line 3585 "XNode.c"
		const gchar* _tmp12_;
		GError* _tmp13_;
#line 411 "../gxml/XNode.vala"
		_tmp12_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) node));
#line 411 "../gxml/XNode.vala"
		_tmp13_ = g_error_new (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to replace invalid node type: %s"), _tmp12_);
#line 411 "../gxml/XNode.vala"
		_inner_error0_ = _tmp13_;
#line 411 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 411 "../gxml/XNode.vala"
		return NULL;
#line 3598 "XNode.c"
	}
#line 414 "../gxml/XNode.vala"
	if (GXML_IS_DOM_TEXT (node)) {
#line 414 "../gxml/XNode.vala"
		_tmp15_ = GXML_IS_DOM_DOCUMENT (self);
#line 3604 "XNode.c"
	} else {
#line 414 "../gxml/XNode.vala"
		_tmp15_ = FALSE;
#line 3608 "XNode.c"
	}
#line 414 "../gxml/XNode.vala"
	if (_tmp15_) {
#line 414 "../gxml/XNode.vala"
		_tmp14_ = TRUE;
#line 3614 "XNode.c"
	} else {
		gboolean _tmp16_ = FALSE;
#line 415 "../gxml/XNode.vala"
		if (GXML_IS_DOM_DOCUMENT_TYPE (node)) {
#line 415 "../gxml/XNode.vala"
			_tmp16_ = !GXML_IS_DOM_DOCUMENT (self);
#line 3621 "XNode.c"
		} else {
#line 415 "../gxml/XNode.vala"
			_tmp16_ = FALSE;
#line 3625 "XNode.c"
		}
#line 415 "../gxml/XNode.vala"
		_tmp14_ = _tmp16_;
#line 3629 "XNode.c"
	}
#line 414 "../gxml/XNode.vala"
	if (_tmp14_) {
#line 3633 "XNode.c"
		GError* _tmp17_;
#line 417 "../gxml/XNode.vala"
		_tmp17_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_HIERARCHY_REQUEST_ERROR, _ ("Invalid attempt to replace a node on a document or text node"));
#line 417 "../gxml/XNode.vala"
		_inner_error0_ = _tmp17_;
#line 417 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 417 "../gxml/XNode.vala"
		return NULL;
#line 3643 "XNode.c"
	}
#line 421 "../gxml/XNode.vala"
	_tmp18_ = gxml_xnode_get_children_nodes (self);
#line 421 "../gxml/XNode.vala"
	_tmp19_ = _tmp18_;
#line 421 "../gxml/XNode.vala"
	_tmp20_ = _tmp19_;
#line 421 "../gxml/XNode.vala"
	_tmp21_ = gee_list_index_of ((GeeList*) _tmp20_, GXML_IS_DOM_NODE (child) ? ((GXmlDomNode*) child) : NULL);
#line 421 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp20_);
#line 421 "../gxml/XNode.vala"
	i = _tmp21_;
#line 422 "../gxml/XNode.vala"
	_tmp22_ = gxml_xnode_get_children_nodes (self);
#line 422 "../gxml/XNode.vala"
	_tmp23_ = _tmp22_;
#line 422 "../gxml/XNode.vala"
	_tmp24_ = _tmp23_;
#line 422 "../gxml/XNode.vala"
	_tmp25_ = gee_list_remove_at ((GeeList*) _tmp24_, i);
#line 422 "../gxml/XNode.vala"
	_tmp26_ = (GXmlDomNode*) _tmp25_;
#line 422 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp24_);
#line 422 "../gxml/XNode.vala"
	rch = _tmp26_;
#line 423 "../gxml/XNode.vala"
	_tmp27_ = gxml_xnode_get_children_nodes (self);
#line 423 "../gxml/XNode.vala"
	_tmp28_ = _tmp27_;
#line 423 "../gxml/XNode.vala"
	_tmp29_ = _tmp28_;
#line 423 "../gxml/XNode.vala"
	_tmp30_ = gee_collection_get_size ((GeeCollection*) _tmp29_);
#line 423 "../gxml/XNode.vala"
	_tmp31_ = _tmp30_;
#line 423 "../gxml/XNode.vala"
	_tmp32_ = i < _tmp31_;
#line 423 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp29_);
#line 423 "../gxml/XNode.vala"
	if (_tmp32_) {
#line 3687 "XNode.c"
		GeeBidirList* _tmp33_;
		GeeBidirList* _tmp34_;
		GeeBidirList* _tmp35_;
#line 424 "../gxml/XNode.vala"
		_tmp33_ = gxml_xnode_get_children_nodes (self);
#line 424 "../gxml/XNode.vala"
		_tmp34_ = _tmp33_;
#line 424 "../gxml/XNode.vala"
		_tmp35_ = _tmp34_;
#line 424 "../gxml/XNode.vala"
		gee_list_insert ((GeeList*) _tmp35_, i, GXML_IS_DOM_NODE (node) ? ((GXmlDomNode*) node) : NULL);
#line 424 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp35_);
#line 3701 "XNode.c"
	}
#line 427 "../gxml/XNode.vala"
	_tmp36_ = gxml_xnode_get_children_nodes (self);
#line 427 "../gxml/XNode.vala"
	_tmp37_ = _tmp36_;
#line 427 "../gxml/XNode.vala"
	_tmp38_ = _tmp37_;
#line 427 "../gxml/XNode.vala"
	_tmp39_ = gee_collection_get_size ((GeeCollection*) _tmp38_);
#line 427 "../gxml/XNode.vala"
	_tmp40_ = _tmp39_;
#line 427 "../gxml/XNode.vala"
	_tmp41_ = i >= _tmp40_;
#line 427 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp38_);
#line 427 "../gxml/XNode.vala"
	if (_tmp41_) {
#line 3719 "XNode.c"
		GXmlDomNodeList* _tmp42_;
		GXmlDomNodeList* _tmp43_;
		GXmlDomNodeList* _tmp44_;
#line 428 "../gxml/XNode.vala"
		_tmp42_ = gxml_dom_node_get_child_nodes ((GXmlDomNode*) self);
#line 428 "../gxml/XNode.vala"
		_tmp43_ = _tmp42_;
#line 428 "../gxml/XNode.vala"
		_tmp44_ = _tmp43_;
#line 428 "../gxml/XNode.vala"
		gee_collection_add ((GeeCollection*) _tmp44_, node);
#line 428 "../gxml/XNode.vala"
		_g_object_unref0 (_tmp44_);
#line 3733 "XNode.c"
	}
#line 431 "../gxml/XNode.vala"
	_tmp45_ = rch;
#line 431 "../gxml/XNode.vala"
	gxml_xnode_release_node (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GXML_TYPE_XNODE, GXmlXNode));
#line 432 "../gxml/XNode.vala"
	gxml_xnode_take_node (G_TYPE_CHECK_INSTANCE_CAST (child, GXML_TYPE_XNODE, GXmlXNode));
#line 434 "../gxml/XNode.vala"
	_tmp46_ = _g_object_ref0 (child);
#line 434 "../gxml/XNode.vala"
	result = _tmp46_;
#line 434 "../gxml/XNode.vala"
	_g_object_unref0 (rch);
#line 434 "../gxml/XNode.vala"
	return result;
#line 3749 "XNode.c"
}

static GXmlDomNode*
gxml_xnode_real_remove_child (GXmlDomNode* base,
                              GXmlDomNode* child,
                              GError** error)
{
	GXmlXNode * self;
	gint i = 0;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* _tmp3_;
	gint _tmp4_;
	GXmlXNode* n = NULL;
	GeeBidirList* _tmp5_;
	GeeBidirList* _tmp6_;
	GeeBidirList* _tmp7_;
	gpointer _tmp8_;
	GXmlXNode* _tmp9_;
	GXmlDomNode* _tmp10_;
	GError* _inner_error0_ = NULL;
	GXmlDomNode* result;
#line 436 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 436 "../gxml/XNode.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 437 "../gxml/XNode.vala"
	if (!gxml_dom_node_contains ((GXmlDomNode*) self, child)) {
#line 3778 "XNode.c"
		GError* _tmp0_;
#line 438 "../gxml/XNode.vala"
		_tmp0_ = g_error_new_literal (GXML_DOM_ERROR, GXML_DOM_ERROR_NOT_FOUND_ERROR, _ ("Can't find child node to remove or child have a different parent"));
#line 438 "../gxml/XNode.vala"
		_inner_error0_ = _tmp0_;
#line 438 "../gxml/XNode.vala"
		g_propagate_error (error, _inner_error0_);
#line 438 "../gxml/XNode.vala"
		return NULL;
#line 3788 "XNode.c"
	}
#line 441 "../gxml/XNode.vala"
	_tmp1_ = gxml_xnode_get_children_nodes (self);
#line 441 "../gxml/XNode.vala"
	_tmp2_ = _tmp1_;
#line 441 "../gxml/XNode.vala"
	_tmp3_ = _tmp2_;
#line 441 "../gxml/XNode.vala"
	_tmp4_ = gee_list_index_of ((GeeList*) _tmp3_, GXML_IS_DOM_NODE (child) ? ((GXmlDomNode*) child) : NULL);
#line 441 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp3_);
#line 441 "../gxml/XNode.vala"
	i = _tmp4_;
#line 442 "../gxml/XNode.vala"
	_tmp5_ = gxml_xnode_get_children_nodes (self);
#line 442 "../gxml/XNode.vala"
	_tmp6_ = _tmp5_;
#line 442 "../gxml/XNode.vala"
	_tmp7_ = _tmp6_;
#line 442 "../gxml/XNode.vala"
	_tmp8_ = gee_list_remove_at ((GeeList*) _tmp7_, i);
#line 442 "../gxml/XNode.vala"
	_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST ((GXmlDomNode*) _tmp8_, GXML_TYPE_XNODE, GXmlXNode);
#line 442 "../gxml/XNode.vala"
	_g_object_unref0 (_tmp7_);
#line 442 "../gxml/XNode.vala"
	n = _tmp9_;
#line 443 "../gxml/XNode.vala"
	gxml_xnode_release_node (n);
#line 444 "../gxml/XNode.vala"
	gxml_xnode_take_node (G_TYPE_CHECK_INSTANCE_CAST (child, GXML_TYPE_XNODE, GXmlXNode));
#line 445 "../gxml/XNode.vala"
	_tmp10_ = _g_object_ref0 (child);
#line 445 "../gxml/XNode.vala"
	result = _tmp10_;
#line 445 "../gxml/XNode.vala"
	_g_object_unref0 (n);
#line 445 "../gxml/XNode.vala"
	return result;
#line 3828 "XNode.c"
}

static void
gxml_xnode_real_add_event_listener (GXmlDomEventTarget* base,
                                    const gchar* type,
                                    GXmlDomEventListener* callback,
                                    gboolean capture)
{
	GXmlXNode * self;
#line 448 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 448 "../gxml/XNode.vala"
	g_return_if_fail (type != NULL);
#line 449 "../gxml/XNode.vala"
	return;
#line 3844 "XNode.c"
}

static void
gxml_xnode_real_remove_event_listener (GXmlDomEventTarget* base,
                                       const gchar* type,
                                       GXmlDomEventListener* callback,
                                       gboolean capture)
{
	GXmlXNode * self;
#line 450 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 450 "../gxml/XNode.vala"
	g_return_if_fail (type != NULL);
#line 451 "../gxml/XNode.vala"
	return;
#line 3860 "XNode.c"
}

static gboolean
gxml_xnode_real_dispatch_event (GXmlDomEventTarget* base,
                                GXmlDomEvent* event,
                                GError** error)
{
	GXmlXNode * self;
	gboolean result;
#line 452 "../gxml/XNode.vala"
	self = (GXmlXNode*) base;
#line 452 "../gxml/XNode.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 453 "../gxml/XNode.vala"
	result = FALSE;
#line 453 "../gxml/XNode.vala"
	return result;
#line 3878 "XNode.c"
}

GXmlXNode*
gxml_xnode_construct (GType object_type)
{
	GXmlXNode * self = NULL;
#line 35 "../gxml/XNode.vala"
	self = (GXmlXNode*) g_object_new (object_type, NULL);
#line 35 "../gxml/XNode.vala"
	return self;
#line 3889 "XNode.c"
}

static GObject *
gxml_xnode_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GXmlXNode * self;
#line 50 "../gxml/XNode.vala"
	parent_class = G_OBJECT_CLASS (gxml_xnode_parent_class);
#line 50 "../gxml/XNode.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../gxml/XNode.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_XNODE, GXmlXNode);
#line 51 "../gxml/XNode.vala"
	gxml_init_init ();
#line 50 "../gxml/XNode.vala"
	return obj;
#line 3910 "XNode.c"
}

static void
gxml_xnode_class_init (GXmlXNodeClass * klass,
                       gpointer klass_data)
{
#line 35 "../gxml/XNode.vala"
	gxml_xnode_parent_class = g_type_class_peek_parent (klass);
#line 35 "../gxml/XNode.vala"
	((GXmlXNodeClass *) klass)->set_namespace = (gboolean (*) (GXmlXNode*, const gchar*, const gchar*)) gxml_xnode_real_set_namespace;
#line 35 "../gxml/XNode.vala"
	((GXmlXNodeClass *) klass)->to_string = (gchar* (*) (GXmlXNode*)) gxml_xnode_real_to_string;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_attrs = (GeeMap* (*) (GXmlXNode*)) gxml_xnode_real_get_attrs;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_children_nodes = (GeeBidirList* (*) (GXmlXNode*)) gxml_xnode_real_get_children_nodes;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_document = (GXmlDomDocument* (*) (GXmlXNode*)) gxml_xnode_real_get_document;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_parent = (GXmlDomNode* (*) (GXmlXNode*)) gxml_xnode_real_get_parent;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_type_node = (GXmlNodeType (*) (GXmlXNode*)) gxml_xnode_real_get_type_node;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_name = (gchar* (*) (GXmlXNode*)) gxml_xnode_real_get_name;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->get_value = (gchar* (*) (GXmlXNode*)) gxml_xnode_real_get_value;
#line 35 "../gxml/XNode.vala"
	GXML_XNODE_CLASS (klass)->set_value = (void (*) (GXmlXNode*, const gchar*)) gxml_xnode_real_set_value;
#line 35 "../gxml/XNode.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_xnode_get_property;
#line 35 "../gxml/XNode.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gxml_xnode_set_property;
#line 35 "../gxml/XNode.vala"
	G_OBJECT_CLASS (klass)->constructor = gxml_xnode_constructor;
#line 35 "../gxml/XNode.vala"
	G_OBJECT_CLASS (klass)->finalize = gxml_xnode_finalize;
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_ATTRS_PROPERTY, gxml_xnode_properties[GXML_XNODE_ATTRS_PROPERTY] = g_param_spec_object ("attrs", "attrs", "attrs", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_CHILDREN_NODES_PROPERTY, gxml_xnode_properties[GXML_XNODE_CHILDREN_NODES_PROPERTY] = g_param_spec_object ("children-nodes", "children-nodes", "children-nodes", GEE_TYPE_BIDIR_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_DOCUMENT_PROPERTY, gxml_xnode_properties[GXML_XNODE_DOCUMENT_PROPERTY] = g_param_spec_object ("document", "document", "document", GXML_TYPE_DOM_DOCUMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_PARENT_PROPERTY, gxml_xnode_properties[GXML_XNODE_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_TYPE_NODE_PROPERTY, gxml_xnode_properties[GXML_XNODE_TYPE_NODE_PROPERTY] = g_param_spec_enum ("type-node", "type-node", "type-node", GXML_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_NAME_PROPERTY, gxml_xnode_properties[GXML_XNODE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_VALUE_PROPERTY, gxml_xnode_properties[GXML_XNODE_VALUE_PROPERTY] = g_param_spec_string ("value", "value", "value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_NODE_TYPE_PROPERTY, gxml_xnode_properties[GXML_XNODE_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", GXML_DOM_NODE_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_NODE_NAME_PROPERTY, gxml_xnode_properties[GXML_XNODE_NODE_NAME_PROPERTY] = g_param_spec_string ("node-name", "node-name", "node-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_BASE_URI_PROPERTY, gxml_xnode_properties[GXML_XNODE_BASE_URI_PROPERTY] = g_param_spec_string ("base-uri", "base-uri", "base-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_OWNER_DOCUMENT_PROPERTY, gxml_xnode_properties[GXML_XNODE_OWNER_DOCUMENT_PROPERTY] = g_param_spec_object ("owner-document", "owner-document", "owner-document", GXML_TYPE_DOM_DOCUMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_PARENT_NODE_PROPERTY, gxml_xnode_properties[GXML_XNODE_PARENT_NODE_PROPERTY] = g_param_spec_object ("parent-node", "parent-node", "parent-node", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_PARENT_ELEMENT_PROPERTY, gxml_xnode_properties[GXML_XNODE_PARENT_ELEMENT_PROPERTY] = g_param_spec_object ("parent-element", "parent-element", "parent-element", GXML_TYPE_DOM_ELEMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_CHILD_NODES_PROPERTY, gxml_xnode_properties[GXML_XNODE_CHILD_NODES_PROPERTY] = g_param_spec_object ("child-nodes", "child-nodes", "child-nodes", GXML_TYPE_DOM_NODE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_FIRST_CHILD_PROPERTY, gxml_xnode_properties[GXML_XNODE_FIRST_CHILD_PROPERTY] = g_param_spec_object ("first-child", "first-child", "first-child", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_LAST_CHILD_PROPERTY, gxml_xnode_properties[GXML_XNODE_LAST_CHILD_PROPERTY] = g_param_spec_object ("last-child", "last-child", "last-child", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_PREVIOUS_SIBLING_PROPERTY, gxml_xnode_properties[GXML_XNODE_PREVIOUS_SIBLING_PROPERTY] = g_param_spec_object ("previous-sibling", "previous-sibling", "previous-sibling", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_NEXT_SIBLING_PROPERTY, gxml_xnode_properties[GXML_XNODE_NEXT_SIBLING_PROPERTY] = g_param_spec_object ("next-sibling", "next-sibling", "next-sibling", GXML_TYPE_DOM_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_NODE_VALUE_PROPERTY, gxml_xnode_properties[GXML_XNODE_NODE_VALUE_PROPERTY] = g_param_spec_string ("node-value", "node-value", "node-value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../gxml/XNode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GXML_XNODE_TEXT_CONTENT_PROPERTY, gxml_xnode_properties[GXML_XNODE_TEXT_CONTENT_PROPERTY] = g_param_spec_string ("text-content", "text-content", "text-content", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3987 "XNode.c"
}

static void
gxml_xnode_gxml_dom_event_target_interface_init (GXmlDomEventTargetIface * iface,
                                                 gpointer iface_data)
{
#line 35 "../gxml/XNode.vala"
	gxml_xnode_gxml_dom_event_target_parent_iface = g_type_interface_peek_parent (iface);
#line 35 "../gxml/XNode.vala"
	iface->add_event_listener = (void (*) (GXmlDomEventTarget*, const gchar*, GXmlDomEventListener*, gboolean)) gxml_xnode_real_add_event_listener;
#line 35 "../gxml/XNode.vala"
	iface->remove_event_listener = (void (*) (GXmlDomEventTarget*, const gchar*, GXmlDomEventListener*, gboolean)) gxml_xnode_real_remove_event_listener;
#line 35 "../gxml/XNode.vala"
	iface->dispatch_event = (gboolean (*) (GXmlDomEventTarget*, GXmlDomEvent*, GError**)) gxml_xnode_real_dispatch_event;
#line 4002 "XNode.c"
}

static void
gxml_xnode_gxml_dom_node_interface_init (GXmlDomNodeIface * iface,
                                         gpointer iface_data)
{
#line 35 "../gxml/XNode.vala"
	gxml_xnode_gxml_dom_node_parent_iface = g_type_interface_peek_parent (iface);
#line 35 "../gxml/XNode.vala"
	iface->has_child_nodes = (gboolean (*) (GXmlDomNode*)) gxml_xnode_real_has_child_nodes;
#line 35 "../gxml/XNode.vala"
	iface->normalize = (void (*) (GXmlDomNode*)) gxml_xnode_real_normalize;
#line 35 "../gxml/XNode.vala"
	iface->is_equal_node = (gboolean (*) (GXmlDomNode*, GXmlDomNode*)) gxml_xnode_real_is_equal_node;
#line 35 "../gxml/XNode.vala"
	iface->compare_document_position = (GXmlDomNodeDocumentPosition (*) (GXmlDomNode*, GXmlDomNode*)) gxml_xnode_real_compare_document_position;
#line 35 "../gxml/XNode.vala"
	iface->contains = (gboolean (*) (GXmlDomNode*, GXmlDomNode*)) gxml_xnode_real_contains;
#line 35 "../gxml/XNode.vala"
	iface->lookup_prefix = (gchar* (*) (GXmlDomNode*, const gchar*)) gxml_xnode_real_lookup_prefix;
#line 35 "../gxml/XNode.vala"
	iface->lookup_namespace_uri = (gchar* (*) (GXmlDomNode*, const gchar*)) gxml_xnode_real_lookup_namespace_uri;
#line 35 "../gxml/XNode.vala"
	iface->is_default_namespace = (gboolean (*) (GXmlDomNode*, const gchar*)) gxml_xnode_real_is_default_namespace;
#line 35 "../gxml/XNode.vala"
	iface->insert_before = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GXmlDomNode*, GError**)) gxml_xnode_real_insert_before;
#line 35 "../gxml/XNode.vala"
	iface->append_child = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GError**)) gxml_xnode_real_append_child;
#line 35 "../gxml/XNode.vala"
	iface->replace_child = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GXmlDomNode*, GError**)) gxml_xnode_real_replace_child;
#line 35 "../gxml/XNode.vala"
	iface->remove_child = (GXmlDomNode* (*) (GXmlDomNode*, GXmlDomNode*, GError**)) gxml_xnode_real_remove_child;
#line 35 "../gxml/XNode.vala"
	iface->get_node_type = gxml_xnode_real_get_node_type;
#line 35 "../gxml/XNode.vala"
	iface->get_node_name = gxml_xnode_real_get_node_name;
#line 35 "../gxml/XNode.vala"
	iface->get_base_uri = gxml_xnode_real_get_base_uri;
#line 35 "../gxml/XNode.vala"
	iface->get_owner_document = gxml_xnode_real_get_owner_document;
#line 35 "../gxml/XNode.vala"
	iface->set_owner_document = gxml_xnode_real_set_owner_document;
#line 35 "../gxml/XNode.vala"
	iface->get_parent_node = gxml_xnode_real_get_parent_node;
#line 35 "../gxml/XNode.vala"
	iface->get_parent_element = gxml_xnode_real_get_parent_element;
#line 35 "../gxml/XNode.vala"
	iface->get_child_nodes = gxml_xnode_real_get_child_nodes;
#line 35 "../gxml/XNode.vala"
	iface->get_first_child = gxml_xnode_real_get_first_child;
#line 35 "../gxml/XNode.vala"
	iface->get_last_child = gxml_xnode_real_get_last_child;
#line 35 "../gxml/XNode.vala"
	iface->get_previous_sibling = gxml_xnode_real_get_previous_sibling;
#line 35 "../gxml/XNode.vala"
	iface->get_next_sibling = gxml_xnode_real_get_next_sibling;
#line 35 "../gxml/XNode.vala"
	iface->get_node_value = gxml_xnode_real_get_node_value;
#line 35 "../gxml/XNode.vala"
	iface->set_node_value = gxml_xnode_real_set_node_value;
#line 35 "../gxml/XNode.vala"
	iface->get_text_content = gxml_xnode_real_get_text_content;
#line 35 "../gxml/XNode.vala"
	iface->set_text_content = gxml_xnode_real_set_text_content;
#line 4067 "XNode.c"
}

static void
gxml_xnode_instance_init (GXmlXNode * self,
                          gpointer klass)
{
#line 41 "../gxml/XNode.vala"
	self->owned_node = FALSE;
#line 209 "../gxml/XNode.vala"
	self->_base_uri = NULL;
#line 4078 "XNode.c"
}

static void
gxml_xnode_finalize (GObject * obj)
{
	GXmlXNode * self;
	gboolean _tmp0_ = FALSE;
#line 35 "../gxml/XNode.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GXML_TYPE_XNODE, GXmlXNode);
#line 55 "../gxml/XNode.vala"
	if (self->owned_node) {
#line 4090 "XNode.c"
		xmlNode* _tmp1_;
#line 55 "../gxml/XNode.vala"
		_tmp1_ = self->_node;
#line 55 "../gxml/XNode.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 4096 "XNode.c"
	} else {
#line 55 "../gxml/XNode.vala"
		_tmp0_ = FALSE;
#line 4100 "XNode.c"
	}
#line 55 "../gxml/XNode.vala"
	if (_tmp0_) {
#line 4104 "XNode.c"
		xmlNode* _tmp2_;
#line 56 "../gxml/XNode.vala"
		_tmp2_ = self->_node;
#line 56 "../gxml/XNode.vala"
		_xmlFreeNode0 (_tmp2_);
#line 57 "../gxml/XNode.vala"
		self->_node = NULL;
#line 4112 "XNode.c"
	}
#line 39 "../gxml/XNode.vala"
	_g_object_unref0 (self->_doc);
#line 209 "../gxml/XNode.vala"
	_g_free0 (self->_base_uri);
#line 35 "../gxml/XNode.vala"
	G_OBJECT_CLASS (gxml_xnode_parent_class)->finalize (obj);
#line 4120 "XNode.c"
}

/**
 * DOM4 Base interface providing basic functionalities to all libxml2 DOM4 implementations.
 */
static GType
gxml_xnode_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlXNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_xnode_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlXNode), 0, (GInstanceInitFunc) gxml_xnode_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_event_target_info = { (GInterfaceInitFunc) gxml_xnode_gxml_dom_event_target_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gxml_dom_node_info = { (GInterfaceInitFunc) gxml_xnode_gxml_dom_node_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_xnode_type_id;
	gxml_xnode_type_id = g_type_register_static (G_TYPE_OBJECT, "GXmlXNode", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (gxml_xnode_type_id, GXML_TYPE_DOM_EVENT_TARGET, &gxml_dom_event_target_info);
	g_type_add_interface_static (gxml_xnode_type_id, GXML_TYPE_DOM_NODE, &gxml_dom_node_info);
	return gxml_xnode_type_id;
}

GType
gxml_xnode_get_type (void)
{
	static volatile gsize gxml_xnode_type_id__once = 0;
	if (g_once_init_enter (&gxml_xnode_type_id__once)) {
		GType gxml_xnode_type_id;
		gxml_xnode_type_id = gxml_xnode_get_type_once ();
		g_once_init_leave (&gxml_xnode_type_id__once, gxml_xnode_type_id);
	}
	return gxml_xnode_type_id__once;
}

static void
_vala_gxml_xnode_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	GXmlXNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_XNODE, GXmlXNode);
#line 35 "../gxml/XNode.vala"
	switch (property_id) {
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_ATTRS_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_xnode_get_attrs (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_CHILDREN_NODES_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_xnode_get_children_nodes (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_DOCUMENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_set_object (value, gxml_xnode_get_document (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_PARENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_xnode_get_parent (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_TYPE_NODE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_set_enum (value, gxml_xnode_get_type_node (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_NAME_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_string (value, gxml_xnode_get_name (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_VALUE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_string (value, gxml_xnode_get_value (self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_NODE_TYPE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_set_enum (value, gxml_dom_node_get_node_type ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_NODE_NAME_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_string (value, gxml_dom_node_get_node_name ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_BASE_URI_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_set_string (value, gxml_dom_node_get_base_uri ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_OWNER_DOCUMENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_set_object (value, gxml_dom_node_get_owner_document ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_PARENT_NODE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_parent_node ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_PARENT_ELEMENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_parent_element ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_CHILD_NODES_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_child_nodes ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_FIRST_CHILD_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_first_child ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_LAST_CHILD_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_last_child ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_PREVIOUS_SIBLING_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_previous_sibling ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_NEXT_SIBLING_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_object (value, gxml_dom_node_get_next_sibling ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_NODE_VALUE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_string (value, gxml_dom_node_get_node_value ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_TEXT_CONTENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		g_value_take_string (value, gxml_dom_node_get_text_content ((GXmlDomNode*) self));
#line 35 "../gxml/XNode.vala"
		break;
#line 4281 "XNode.c"
		default:
#line 35 "../gxml/XNode.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../gxml/XNode.vala"
		break;
#line 4287 "XNode.c"
	}
}

static void
_vala_gxml_xnode_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	GXmlXNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_XNODE, GXmlXNode);
#line 35 "../gxml/XNode.vala"
	switch (property_id) {
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_VALUE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		gxml_xnode_set_value (self, g_value_get_string (value));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_OWNER_DOCUMENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		gxml_dom_node_set_owner_document ((GXmlDomNode*) self, g_value_get_object (value));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_NODE_VALUE_PROPERTY:
#line 35 "../gxml/XNode.vala"
		gxml_dom_node_set_node_value ((GXmlDomNode*) self, g_value_get_string (value));
#line 35 "../gxml/XNode.vala"
		break;
#line 35 "../gxml/XNode.vala"
		case GXML_XNODE_TEXT_CONTENT_PROPERTY:
#line 35 "../gxml/XNode.vala"
		gxml_dom_node_set_text_content ((GXmlDomNode*) self, g_value_get_string (value));
#line 35 "../gxml/XNode.vala"
		break;
#line 4325 "XNode.c"
		default:
#line 35 "../gxml/XNode.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../gxml/XNode.vala"
		break;
#line 4331 "XNode.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 245 "../gxml/Parser.vala"
	if (mem && byte_size != 0) {
#line 245 "../gxml/Parser.vala"
		new_mem = g_malloc (byte_size);
#line 245 "../gxml/Parser.vala"
		memcpy (new_mem, mem, byte_size);
#line 4346 "XNode.c"
	} else {
#line 245 "../gxml/Parser.vala"
		new_mem = NULL;
#line 4350 "XNode.c"
	}
#line 245 "../gxml/Parser.vala"
	return new_mem;
#line 4354 "XNode.c"
}

